/*------------------------------------------------------------------------------
** Projet : trainsim                                                         
** Auteurs : Vincent BONESTEVE, Dominique PADIOU                           
** Module : api                                                        
** Fichier : api_kernel.c                                     
** Description : API to use kernel for endusers, all API calls will be 
**               translated to kernel calls
------------------------------------------------------------------------------*/
/**
 * \file api_kernel.c
 * \brief Module : api, API to use kernel for endusers, all API calls will be 
 *        translated to kernel calls
 * \author Vincent BONESTEVE, Dominique PADIOU 
 * \version 1.0-stable
 * \date 22/01/2010
 */
#include "api_kernel.h"
/*
TSAPI
*/
/*
TSAPI_aiguillages
*/
int TSAPI_aiguillages_setPosition(char* aiguillage_num,char* aiguillage_pos){
	int aiguillage_real_num1;
	int aiguillage_real_pos1;
	int aiguillage_real_num2;
	int aiguillage_real_pos2;	

	if (strcmp(aiguillage_num,"S1")==0){
		aiguillage_real_num1=AIGUILLAGES_AIGUILLAGE_S1;
		if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_CENTRE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_2;
		} else {
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
		}
		return TSKERNEL_MOD_aiguillages_simple_setPosition(aiguillage_real_num1,aiguillage_real_pos1);
	} else if (strcmp(aiguillage_num,"S2")==0){
		aiguillage_real_num1=AIGUILLAGES_AIGUILLAGE_S2;
		if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_CENTRE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
		} else {
			aiguillage_real_pos1=AIGUILLAGES_POSITION_2;
		}
		return TSKERNEL_MOD_aiguillages_simple_setPosition(aiguillage_real_num1,aiguillage_real_pos1);
	} else if (strcmp(aiguillage_num,"X1")==0){
		aiguillage_real_num1=AIGUILLAGES_CROISEMENT;
		if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_CROISEMENT)==0){
			aiguillage_real_pos1=AIGUILLAGES_CROISEMENT_POSITION_CROISEMENT;
		} else {
			aiguillage_real_pos1=AIGUILLAGES_CROISEMENT_POSITION_BIFURCATION;
		}
		return TSKERNEL_MOD_aiguillages_croisement_setPosition(aiguillage_real_num1,aiguillage_real_pos1);
	} else if (strcmp(aiguillage_num,"D1")==0){
		aiguillage_real_num1=AIGUILLAGES_AIGUILLAGE_D1_1;
		aiguillage_real_num2=AIGUILLAGES_AIGUILLAGE_D1_2;
		if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_GAUCHE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_2;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_2;
		} else if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_CENTRE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_2;
		} else if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_DROITE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_1;
		}
		return TSKERNEL_MOD_aiguillages_double_setPosition(aiguillage_real_num1,aiguillage_real_pos1,aiguillage_real_num2,aiguillage_real_pos2);
	} else if (strcmp(aiguillage_num,"D2")==0){
		aiguillage_real_num1=AIGUILLAGES_AIGUILLAGE_D2_1;
		aiguillage_real_num2=AIGUILLAGES_AIGUILLAGE_D2_2;
		if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_GAUCHE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_2;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_2;
		} else if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_CENTRE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_2;
		} else if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_DROITE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_1;
		}
		return TSKERNEL_MOD_aiguillages_double_setPosition(aiguillage_real_num1,aiguillage_real_pos1,aiguillage_real_num2,aiguillage_real_pos2);
	} else if (strcmp(aiguillage_num,"D3")==0){
		aiguillage_real_num1=AIGUILLAGES_AIGUILLAGE_D3_1;
		aiguillage_real_num2=AIGUILLAGES_AIGUILLAGE_D3_2;
		if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_GAUCHE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_2;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_2;
		} else if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_CENTRE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_2;
		} else if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_DROITE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_1;
		}
		return TSKERNEL_MOD_aiguillages_double_setPosition(aiguillage_real_num1,aiguillage_real_pos1,aiguillage_real_num2,aiguillage_real_pos2);
	} else if (strcmp(aiguillage_num,"D4")==0){
		aiguillage_real_num1=AIGUILLAGES_AIGUILLAGE_D4_1;
		aiguillage_real_num2=AIGUILLAGES_AIGUILLAGE_D4_2;
		if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_GAUCHE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_2;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_2;
		} else if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_CENTRE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_2;
		} else if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_DROITE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_1;
		}
		return TSKERNEL_MOD_aiguillages_double_setPosition(aiguillage_real_num1,aiguillage_real_pos1,aiguillage_real_num2,aiguillage_real_pos2);
	}
	return TSKERNEL_NORMAL_EXIT; 
}

/*
TSAPI_blocks
*/
int TSAPI_blocks_mutex_P(int block_num,int train_num){
	return TSKERNEL_blocks_mutex_P(block_num,train_num);
}
int TSAPI_blocks_mutex_V(int block_num,int train_num){
	return TSKERNEL_blocks_mutex_V(block_num,train_num);
}

/*
TSAPI_circuit
*/
int TSAPI_circuit_relachement(void){
	return TSKERNEL_MOD_circuit_relachement();
}
int TSAPI_circuit_disjonction(void){
	return TSKERNEL_MOD_circuit_disjonction();
}
int TSAPI_circuit_conjonction(void){
	return TSKERNEL_MOD_circuit_conjonction();
}

/*
TASPI_detelages
*/
int TSAPI_detelages_getPosition(int detelage_num){
	return TSKERNEL_MOD_detelages_getPosition(detelage_num);
}
int TSAPI_detelages_setPosition(char* detelage_name,int pos){
	int detelage_num;
	if (strcmp(detelage_name,DETELAGES_TXT_DET1)==0){
		detelage_num=DETELAGES_RAIL_DET1;
	} else if (strcmp(detelage_name,DETELAGES_TXT_DET2)==0){
		detelage_num=DETELAGES_RAIL_DET2;
	} else if (strcmp(detelage_name,DETELAGES_TXT_DET3)==0){
		detelage_num=DETELAGES_RAIL_DET3;
	}
	return TSKERNEL_MOD_detelages_setPosition(detelage_num,pos);
}

/*
TASPI_receptivities
*/
int TSAPI_receptivities_get(int octet,int bit){
	return TSKERNEL_MOD_receptivities_get(octet,bit);
}

/*
TSAPI_signalisation
*/
int TSAPI_signalisation_setState(int signal_num, int state){
	return TSKERNEL_MOD_signalisation_setState(signal_num,state);
}
int TSAPI_signalisation_getState(int signal_num){
	return TSKERNEL_MOD_signalisation_getState(signal_num);
}

/*
TSAPI_trains
*/
int TSAPI_trains_getSpeed(int train_num){
	return TSKERNEL_MOD_trains_getSpeed(train_num);
}
int TSAPI_trains_getPosition(int train_num){
	return TSKERNEL_MOD_trains_getPosition(train_num);
}
int TSAPI_trains_setSpeed(int train_num,int speed,int fct){
	return TSKERNEL_MOD_trains_setSpeed(train_num,speed,fct);
}
int TSAPI_trains_reverse(int train_num,int fct){
	return TSKERNEL_MOD_trains_reverse(train_num,fct);
}

int TSAPI_trains_createItinerary(int train_num,int startBlock_num){
	return TSKERNEL_MOD_trains_createItinerary(train_num,startBlock_num);
}
int TSAPI_trains_deleteItinerary(int train_num){
	return TSKERNEL_MOD_trains_deleteItinerary(train_num);
}

