/*------------------------------------------------------------------------------
** Projet : trainsim                                                         
** Auteurs : Vincent BONESTEVE, Dominique PADIOU                           
** Module : const                                                        
** Fichier : const_aiguillages.h                                    
** Description : Constantes pour la gestion des aiguillages                             
------------------------------------------------------------------------------*/
/**
 * \file const_aiguillages.h
 * \brief Module : const, Constantes pour la gestion des aiguillages 
 * \author Vincent BONESTEVE, Dominique PADIOU 
 * \version 1.0-stable
 * \date 30/12/2009
 */
#ifndef CONST_AIGUILLAGES_H
#define CONST_AIGUILLAGES_H
/*
Codes positions
*/
#define AIGUILLAGES_POSITION_1 33
#define AIGUILLAGES_POSITION_2 34

/*
Aiguillages simples
*/
#define AIGUILLAGES_AIGUILLAGE_S1 18
#define AIGUILLAGES_AIGUILLAGE_S2 39

/*
Aiguillages doubles
*/
#define AIGUILLAGES_AIGUILLAGE_D1_1 17
#define AIGUILLAGES_AIGUILLAGE_D1_2 24
#define AIGUILLAGES_AIGUILLAGE_D2_1 40
#define AIGUILLAGES_AIGUILLAGE_D2_2 38
#define AIGUILLAGES_AIGUILLAGE_D3_1 97
#define AIGUILLAGES_AIGUILLAGE_D3_2 104
#define AIGUILLAGES_AIGUILLAGE_D4_1 117
#define AIGUILLAGES_AIGUILLAGE_D4_2 113

/*
Croisement
*/
#define AIGUILLAGES_CROISEMENT 84
#define AIGUILLAGES_CROISEMENT_POSITION_CROISEMENT 33
#define AIGUILLAGES_CROISEMENT_POSITION_BIFURCATION 34

/*
Global
*/
#define AIGUILLAGES_NB_AIGUILLAGES 11
static int AIGUILLAGES_NUMS[AIGUILLAGES_NB_AIGUILLAGES] = {
AIGUILLAGES_AIGUILLAGE_S1,AIGUILLAGES_AIGUILLAGE_S2,
AIGUILLAGES_AIGUILLAGE_D1_1,AIGUILLAGES_AIGUILLAGE_D1_2,
AIGUILLAGES_AIGUILLAGE_D2_1,AIGUILLAGES_AIGUILLAGE_D2_2,
AIGUILLAGES_AIGUILLAGE_D3_1,AIGUILLAGES_AIGUILLAGE_D3_2,
AIGUILLAGES_AIGUILLAGE_D4_1,AIGUILLAGES_AIGUILLAGE_D4_2,
AIGUILLAGES_CROISEMENT};

#endif
