/*------------------------------------------------------------------------------
** Projet : trainsim                                                         
** Auteurs : Vincent BONESTEVE, Dominique PADIOU                           
** Module : const                                                        
** Fichier : const_kernel.h                                    
** Description : Constantes internes au noyau et à ses modules                         
------------------------------------------------------------------------------*/
/**
 * \file const_kernel.h
 * \brief Module : const, Constantes internes au noyau et à ses modules
 * \author Vincent BONESTEVE, Dominique PADIOU 
 * \version 1.0-stable
 * \date 30/12/2009
 */
#ifndef CONST_KERNEL_H
#define CONST_KERNEL_H
/*
Trace
*/
#define TSKERNEL_TRACE_NO	0
#define TSKERNEL_TRACE_ERROR	1
#define TSKERNEL_TRACE_INFO	2
#define TSKERNEL_TRACE_DEBUG	3
#define TSKERNEL_TRACE_INTERNAL	4

/*
Code type
*/
#define TSKERNEL_CODE_USER	0
#define TSKERNEL_CODE_KERNEL_NORT 1
#define TSKERNEL_CODE_KERNEL_RT	2

/*
Simulation
*/
#define TSKERNEL_SIMUL_ON 1
#define TSKERNEL_SIMUL_OFF 0

/*
Run configuration
*/
#define TSKERNEL_RUN_ON 1
#define TSKERNEL_RUN_OFF 0
#define TSKERNEL_RUN_STOP 2

/*
Thread-safe flags
*/
#define TSKERNEL_THREADSAFE_ON 1
#define TSKERNEL_THREADSAFE_OFF 0

/*
Erreurs
*/
#define TSKERNEL_NORMAL_EXIT 0

#define TSKERNEL_INVALID_SIGNAL -1
#define TSKERNEL_INVALID_SIGNAL_COLOR -2

#define TSKERNEL_INVALID_AIGUILLAGE -10
#define TSKERNEL_INVALID_AIGUILLAGE_POSITION -11

#define TSKERNEL_INVALID_DETELAGE -20
#define TSKERNEL_INVALID_DETELAGE_POSITION -21

#define TSKERNEL_INVALID_BLOCK -30
#define TSKERNEL_INACTIVE_BLOCK -31

#define TSKERNEL_INVALID_TRAIN -40
#define TSKERNEL_INVALID_TRAIN_SPEED -41
#define TSKERNEL_INVALID_TRAIN_FCT -42
#define TSKERNEL_INVALID_TRAIN_POSITION -43
#define TSKERNEL_INACTIVE_TRAIN -44
#define TSKERNEL_ACTIVE_TRAIN -45

#define TSKERNEL_INVALID_DECODER -50
#define TSKERNEL_INVALID_RECEPTIVITY -51

#define TSKERNEL_INVALID_SERIAL_READ -60
#define TSKERNEL_INVALID_SERIAL_WRITE -61

#define TSKERNEL_INVALID_SOCKET -70

#define TSKERNEL_INVALID_TRACE_LEVEL -100

/*
Options de compilation
*/
//#define TS_RTAI 1
//#define TS_NOGUI 1
//#define TSKERNEL_DEBUG_TO_CONSOLE 1
#endif
