/*------------------------------------------------------------------------------
** Projet : trainsim                                                         
** Auteurs : Vincent BONESTEVE, Dominique PADIOU                           
** Module : const                                                        
** Fichier : const_signalisation.h                                    
** Description : Constantes pour la gestion de la signalisation                            
------------------------------------------------------------------------------*/
/**
 * \file const_signalisation.h
 * \brief Module : const, Constantes pour la gestion de la signalisation
 * \author Vincent BONESTEVE, Dominique PADIOU 
 * \version 1.0-stable
 * \date 30/12/2009
 */
#ifndef CONST_SIGNALISATION_H
#define CONST_SIGNALISATION_H
/*
Codes couleurs
*/
#define SIGNALISATION_COLOR_GREEN 33
#define SIGNALISATION_COLOR_RED 34

/*
Convention de sens
*/
#define SIGNALISATION_SENS_1 0
#define SIGNALISATION_SENS_2 1

/*
Signaux
*/
#define SIGNALISATION_NB_SIGNAUX 34

#define SIGNALISATION_NUM_1 1
#define SIGNALISATION_NUM_4 4
#define SIGNALISATION_NUM_19 19
#define SIGNALISATION_NUM_20 20
#define SIGNALISATION_NUM_21 21
#define SIGNALISATION_NUM_22 22
#define SIGNALISATION_NUM_23 23
#define SIGNALISATION_NUM_33 33
#define SIGNALISATION_NUM_34 34
#define SIGNALISATION_NUM_35 35
#define SIGNALISATION_NUM_36 36
#define SIGNALISATION_NUM_37 37
#define SIGNALISATION_NUM_49 49
#define SIGNALISATION_NUM_50 50
#define SIGNALISATION_NUM_51 51
#define SIGNALISATION_NUM_52 52
#define SIGNALISATION_NUM_65 65
#define SIGNALISATION_NUM_66 66
#define SIGNALISATION_NUM_67 67
#define SIGNALISATION_NUM_68 68
#define SIGNALISATION_NUM_85 85
#define SIGNALISATION_NUM_86 86
#define SIGNALISATION_NUM_87 87
#define SIGNALISATION_NUM_88 88
#define SIGNALISATION_NUM_98 98
#define SIGNALISATION_NUM_99 99
#define SIGNALISATION_NUM_100 100
#define SIGNALISATION_NUM_103 103
#define SIGNALISATION_NUM_114 114
#define SIGNALISATION_NUM_115 115
#define SIGNALISATION_NUM_116 116
#define SIGNALISATION_NUM_118 118
#define SIGNALISATION_NUM_129 129
#define SIGNALISATION_NUM_130 130
static int SIGNALISATION_NUMS[SIGNALISATION_NB_SIGNAUX] = {1,4,19,20,21,22,23,33,34,35,36,37,49,50,51,52,65,66,67,68,85,86,87,88,98,99,100,103,114,115,116,118,129,130};

/*
Signaux par block
*/
static int SIGNALISATION_SIGNAUX_G1[2]={19,19};
static int SIGNALISATION_SIGNAUX_G2[2]={33,33};

static int SIGNALISATION_SIGNAUX_B1[2]={20,4};
static int SIGNALISATION_SIGNAUX_B2[2]={1,37};
static int SIGNALISATION_SIGNAUX_B3[2]={49,23};
static int SIGNALISATION_SIGNAUX_B4[2]={50,21};
static int SIGNALISATION_SIGNAUX_B5[2]={68,22};
static int SIGNALISATION_SIGNAUX_B6[2]={36,65};
static int SIGNALISATION_SIGNAUX_B7[2]={35,86};
static int SIGNALISATION_SIGNAUX_B8[2]={34,85};
static int SIGNALISATION_SIGNAUX_B9[2]={99,52};
static int SIGNALISATION_SIGNAUX_B10[2]={100,51};
static int SIGNALISATION_SIGNAUX_B11[2]={98,67};
static int SIGNALISATION_SIGNAUX_B12[2]={66,115};
static int SIGNALISATION_SIGNAUX_B13[2]={87,116};
static int SIGNALISATION_SIGNAUX_B14[2]={88,114};
static int SIGNALISATION_SIGNAUX_B15[2]={130,103};
static int SIGNALISATION_SIGNAUX_B16[2]={118,129};

#endif

