/*------------------------------------------------------------------------------
** Projet : trainsim                                                         
** Auteurs : Vincent BONESTEVE, Dominique PADIOU                           
** Module : const                                                        
** Fichier : const_trains.h                                    
** Description : Constantes pour le pilotage des trains                                  
------------------------------------------------------------------------------*/
/**
 * \file const_trains.h
 * \brief Module : const, Constantes pour le pilotage des trains
 * \author Vincent BONESTEVE, Dominique PADIOU 
 * \version 1.0-stable
 * \date 30/12/2009
 */
#ifndef CONST_TRAINS_H
#define CONST_TRAINS_H
/*
Etat des trains
*/
#define TRAINS_STATE_ACTIVE 1
#define TRAINS_STATE_NOT_ACTIVE 0

/*
Fct
*/
#define TRAINS_FCT_OFF 0
#define TRAINS_FCT_ON 1

/*
Commande des trains sans activation de la fonction annexe
*/
#define TRAINS_CMD_NOFCT_ARRET 0
#define TRAINS_CMD_NOFCT_VITESSE_MIN 1
#define TRAINS_CMD_NOFCT_VITESSE_2 2
#define TRAINS_CMD_NOFCT_VITESSE_3 3
#define TRAINS_CMD_NOFCT_VITESSE_4 4
#define TRAINS_CMD_NOFCT_VITESSE_5 5
#define TRAINS_CMD_NOFCT_VITESSE_6 6
#define TRAINS_CMD_NOFCT_VITESSE_7 7
#define TRAINS_CMD_NOFCT_VITESSE_8 8
#define TRAINS_CMD_NOFCT_VITESSE_9 9
#define TRAINS_CMD_NOFCT_VITESSE_10 10
#define TRAINS_CMD_NOFCT_VITESSE_11 11
#define TRAINS_CMD_NOFCT_VITESSE_12 12
#define TRAINS_CMD_NOFCT_VITESSE_13 13
#define TRAINS_CMD_NOFCT_VITESSE_MAX 14
#define TRAINS_CMD_NOFCT_INVERSION 15

/*
Commande des trains avec activation de la fonction annexe
*/
#define TRAINS_CMD_WITHFCT_ARRET 16
#define TRAINS_CMD_WITHFCT_VITESSE_MIN 17
#define TRAINS_CMD_WITHFCT_VITESSE_2 18
#define TRAINS_CMD_WITHFCT_VITESSE_3 19
#define TRAINS_CMD_WITHFCT_VITESSE_4 20
#define TRAINS_CMD_WITHFCT_VITESSE_5 21
#define TRAINS_CMD_WITHFCT_VITESSE_6 22
#define TRAINS_CMD_WITHFCT_VITESSE_7 23
#define TRAINS_CMD_WITHFCT_VITESSE_8 24
#define TRAINS_CMD_WITHFCT_VITESSE_9 25
#define TRAINS_CMD_WITHFCT_VITESSE_10 26
#define TRAINS_CMD_WITHFCT_VITESSE_11 27
#define TRAINS_CMD_WITHFCT_VITESSE_12 28
#define TRAINS_CMD_WITHFCT_VITESSE_13 29
#define TRAINS_CMD_WITHFCT_VITESSE_MAX 30
#define TRAINS_CMD_WITHFCT_INVERSION 31

/*
Identifiants des locomotives
*/
#define TRAINS_LOCOMOTIVE_NOT_ASSIGNED 0
#define TRAINS_LOCOMOTIVE_1 10
#define TRAINS_LOCOMOTIVE_2 20
#define TRAINS_LOCOMOTIVE_3 30
#define TRAINS_LOCOMOTIVE_4 40
#define TRAINS_LOCOMOTIVE_5 50
#define TRAINS_LOCOMOTIVE_6 60
#define TRAINS_LOCOMOTIVE_7 70
#define TRAINS_LOCOMOTIVE_8 80

#define TRAINS_NB_LOCOMOTIVES 8
static int TRAINS_NUMS[TRAINS_NB_LOCOMOTIVES]={
TRAINS_LOCOMOTIVE_1,TRAINS_LOCOMOTIVE_2,TRAINS_LOCOMOTIVE_3,TRAINS_LOCOMOTIVE_4,
TRAINS_LOCOMOTIVE_5,TRAINS_LOCOMOTIVE_6,TRAINS_LOCOMOTIVE_7,TRAINS_LOCOMOTIVE_8};
#endif
