/*------------------------------------------------------------------------------
** Projet : trainsim                                                         
** Auteurs : Vincent BONESTEVE, Dominique PADIOU                           
** Module : gui                                                    
** Fichier : gui_callbacks.c
** Description : callbacks boutons gui                          
------------------------------------------------------------------------------*/
/**
 * \file gui_callbacks.c
 * \brief Module : gui, Callbacks des boutons de la gui 
 * \author Vincent BONESTEVE, Dominique PADIOU 
 * \version 1.0-stable
 * \date 01/01/2010
 */
#include "gui_callbacks.h"

gboolean TSGUI_on_Quit(GtkWidget *pWindow, GdkEvent *pEvent,gpointer data){
	GtkWidget *pQuestion;

	pQuestion = gtk_message_dialog_new (GTK_WINDOW(data),GTK_DIALOG_MODAL,GTK_MESSAGE_WARNING,GTK_BUTTONS_YES_NO,"Etes-vous sur de vouloir quitter ? Les traitements en cours seront perdus.");

	/* Affichage et attente d une reponse */
	switch(gtk_dialog_run(GTK_DIALOG(pQuestion))){
		case GTK_RESPONSE_YES:
		/* OUI -> on quitte l application */
		gtk_main_quit();
		break;
		case GTK_RESPONSE_NO:
		/* NON -> on detruit la boite de message */
			gtk_widget_destroy(pQuestion);
			return TRUE;
		break;
	}
	return TRUE;
}

void TSGUI_on_quitter1_activate(GtkMenuItem *menuitem,gpointer user_data){
	GtkWidget *pQuestion;

	pQuestion = gtk_message_dialog_new (GTK_WINDOW(user_data),GTK_DIALOG_MODAL,GTK_MESSAGE_WARNING,GTK_BUTTONS_YES_NO,"Etes-vous sur de vouloir quitter ? Les traitements en cours seront perdus.");

	/* Affichage et attente d une reponse */
	switch(gtk_dialog_run(GTK_DIALOG(pQuestion))){
		case GTK_RESPONSE_YES:
			/* OUI -> on quitte l application */
			gtk_main_quit();
		break;
		case GTK_RESPONSE_NO:
			/* NON -> on detruit la boite de message */
			gtk_widget_destroy(pQuestion);
	   		return ;
		break;
   }
}


void TSGUI_on_about1_activate(GtkMenuItem *menuitem,gpointer user_data){
	GtkWidget *pQuestion;
	pQuestion = gtk_message_dialog_new (GTK_WINDOW(user_data),GTK_DIALOG_MODAL,GTK_MESSAGE_INFO,GTK_BUTTONS_CLOSE,"Simulateur de trains avec commandes\ndu circuit.\n\nAuteurs :\nVincent BONESTEVE\nDominique PADIOU\n\n(c) 2009 - 2010 Tous droits r\303\251serv\303\251s");
	gtk_dialog_run(GTK_DIALOG(pQuestion));
	gtk_widget_destroy (pQuestion);
}


void TSGUI_on_signalisationbutton_pressed(GtkButton *button,gpointer user_data){
	int signal_num=(int)atoi(gtk_combo_box_get_active_text(GTK_COMBO_BOX(lookup_widget((GtkWidget*)TSGUI_mainWindow,"TSGUI_signal_num"))));
	int signal_color=0;
	char* color=gtk_combo_box_get_active_text(GTK_COMBO_BOX(lookup_widget((GtkWidget*)TSGUI_mainWindow,"TSGUI_signal_color")));
	if (strcmp(color,"vert")==0){
		signal_color=SIGNALISATION_COLOR_GREEN;
	} else {
		signal_color=SIGNALISATION_COLOR_RED;
	}
	TSKERNEL_MOD_signalisation_setState(signal_num,signal_color);
	TSGUI_update(TSKERNEL_THREADSAFE_OFF);
}


void TSGUI_on_aiguillagesButton_pressed(GtkButton *button,gpointer user_data){
	char* aiguillage_num=(char*)gtk_combo_box_get_active_text(GTK_COMBO_BOX(lookup_widget((GtkWidget*)TSGUI_mainWindow,"TSGUI_aiguillage_num")));
	char* aiguillage_pos=(char*)gtk_combo_box_get_active_text(GTK_COMBO_BOX(lookup_widget((GtkWidget*)TSGUI_mainWindow,"TSGUI_aiguillage_pos")));
	
	int aiguillage_real_num1=0;
	int aiguillage_real_pos1=0;
	int aiguillage_real_num2=0;
	int aiguillage_real_pos2=0;	

	if (strcmp(aiguillage_num,"S1")==0){
		aiguillage_real_num1=AIGUILLAGES_AIGUILLAGE_S1;
		if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_CENTRE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_2;
		} else {
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
		}
		TSKERNEL_MOD_aiguillages_simple_setPosition(aiguillage_real_num1,aiguillage_real_pos1);
	} else if (strcmp(aiguillage_num,"S2")==0){
		aiguillage_real_num1=AIGUILLAGES_AIGUILLAGE_S2;
		if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_CENTRE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
		} else {
			aiguillage_real_pos1=AIGUILLAGES_POSITION_2;
		}
		TSKERNEL_MOD_aiguillages_simple_setPosition(aiguillage_real_num1,aiguillage_real_pos1);
	} else if (strcmp(aiguillage_num,"X1")==0){
		aiguillage_real_num1=AIGUILLAGES_CROISEMENT;
		if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_CROISEMENT)==0){
			aiguillage_real_pos1=AIGUILLAGES_CROISEMENT_POSITION_CROISEMENT;
		} else {
			aiguillage_real_pos1=AIGUILLAGES_CROISEMENT_POSITION_BIFURCATION;
		}
		TSKERNEL_MOD_aiguillages_croisement_setPosition(aiguillage_real_num1,aiguillage_real_pos1);
	} else if (strcmp(aiguillage_num,"D1")==0){
		aiguillage_real_num1=AIGUILLAGES_AIGUILLAGE_D1_1;
		aiguillage_real_num2=AIGUILLAGES_AIGUILLAGE_D1_2;
		if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_GAUCHE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_2;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_2;
		} else if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_CENTRE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_2;
		} else if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_DROITE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_1;
		}
		TSKERNEL_MOD_aiguillages_double_setPosition(aiguillage_real_num1,aiguillage_real_pos1,aiguillage_real_num2,aiguillage_real_pos2);
	} else if (strcmp(aiguillage_num,"D2")==0){
		aiguillage_real_num1=AIGUILLAGES_AIGUILLAGE_D2_1;
		aiguillage_real_num2=AIGUILLAGES_AIGUILLAGE_D2_2;
		if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_GAUCHE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_2;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_2;
		} else if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_CENTRE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_2;
		} else if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_DROITE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_1;
		}
		TSKERNEL_MOD_aiguillages_double_setPosition(aiguillage_real_num1,aiguillage_real_pos1,aiguillage_real_num2,aiguillage_real_pos2);
	} else if (strcmp(aiguillage_num,"D3")==0){
		aiguillage_real_num1=AIGUILLAGES_AIGUILLAGE_D3_1;
		aiguillage_real_num2=AIGUILLAGES_AIGUILLAGE_D3_2;
		if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_GAUCHE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_2;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_2;
		} else if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_CENTRE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_2;
		} else if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_DROITE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_1;
		}
		TSKERNEL_MOD_aiguillages_double_setPosition(aiguillage_real_num1,aiguillage_real_pos1,aiguillage_real_num2,aiguillage_real_pos2);
	} else if (strcmp(aiguillage_num,"D4")==0){
		aiguillage_real_num1=AIGUILLAGES_AIGUILLAGE_D4_1;
		aiguillage_real_num2=AIGUILLAGES_AIGUILLAGE_D4_2;
		if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_GAUCHE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_2;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_2;
		} else if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_CENTRE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_2;
		} else if (strcmp(aiguillage_pos,AIGUILLAGES_TXT_DROITE)==0){
			aiguillage_real_pos1=AIGUILLAGES_POSITION_1;
			aiguillage_real_pos2=AIGUILLAGES_POSITION_1;
		}
		TSKERNEL_MOD_aiguillages_double_setPosition(aiguillage_real_num1,aiguillage_real_pos1,aiguillage_real_num2,aiguillage_real_pos2);
	}
	TSGUI_update(TSKERNEL_THREADSAFE_OFF);
}


void TSGUI_on_receptivitiesButton_pressed(GtkButton *button,gpointer user_data){
	int receptivities_octet=(int)atoi(gtk_combo_box_get_active_text(GTK_COMBO_BOX(lookup_widget((GtkWidget*)TSGUI_mainWindow,"TSGUI_receptivities_octet"))));
	int receptivities_bit=(int)atoi(gtk_combo_box_get_active_text(GTK_COMBO_BOX(lookup_widget((GtkWidget*)TSGUI_mainWindow,"TSGUI_receptivities_bit"))));
	char* receptivities_value=(char*)gtk_combo_box_get_active_text(GTK_COMBO_BOX(lookup_widget((GtkWidget*)TSGUI_mainWindow,"TSGUI_receptivities_value")));
	int receptivities_real_value;
	if (strcmp(receptivities_value,"on")==0){
		receptivities_real_value=RECEPTIVITIES_STATE_ON;
	} else {
		receptivities_real_value=RECEPTIVITIES_STATE_OFF;
	}
	TSKERNEL_MOD_receptivities_set(receptivities_octet,receptivities_bit,receptivities_real_value);
}


void TSGUI_on_trains_invButton_pressed(GtkButton *button,gpointer user_data){
	int train_num=(int)atoi(gtk_combo_box_get_active_text(GTK_COMBO_BOX(lookup_widget((GtkWidget*)TSGUI_mainWindow,"TSGUI_trains_num"))));
	char* trains_fct=(char*)gtk_combo_box_get_active_text(GTK_COMBO_BOX(lookup_widget((GtkWidget*)TSGUI_mainWindow,"TSGUI_trains_fct")));
	int trains_fct_real_value=0;
	if (strcmp(trains_fct,"on")==0){
		trains_fct_real_value=TRAINS_FCT_ON;
	} else {
		trains_fct_real_value=TRAINS_FCT_OFF;
	}
	TSKERNEL_MOD_trains_reverse(train_num,trains_fct_real_value);
	TSGUI_update(TSKERNEL_THREADSAFE_OFF);
}


void TSGUI_on_trainsButton_pressed(GtkButton *button,gpointer user_data){
	int train_num=(int)atoi(gtk_combo_box_get_active_text(GTK_COMBO_BOX(lookup_widget((GtkWidget*)TSGUI_mainWindow,"TSGUI_trains_num"))));
	int train_speed=(int)atoi(gtk_combo_box_get_active_text(GTK_COMBO_BOX(lookup_widget((GtkWidget*)TSGUI_mainWindow,"TSGUI_trains_speed"))));
	char* trains_fct=(char*)gtk_combo_box_get_active_text(GTK_COMBO_BOX(lookup_widget((GtkWidget*)TSGUI_mainWindow,"TSGUI_trains_fct")));
	int trains_fct_real_value=0;
	if (strcmp(trains_fct,"on")==0){
		trains_fct_real_value=TRAINS_FCT_ON;
	} else {
		trains_fct_real_value=TRAINS_FCT_OFF;
	}
	TSKERNEL_MOD_trains_setSpeed(train_num,train_speed,trains_fct_real_value);
	TSGUI_update(TSKERNEL_THREADSAFE_OFF);
}

void TSGUI_on_detelagesButton_pressed(GtkButton *button,gpointer user_data){
	char* detelage_name=(char*)gtk_combo_box_get_active_text(GTK_COMBO_BOX(lookup_widget((GtkWidget*)TSGUI_mainWindow,"TSGUI_detelages_num")));
	char* detelage_state=(char*)gtk_combo_box_get_active_text(GTK_COMBO_BOX(lookup_widget((GtkWidget*)TSGUI_mainWindow,"TSGUI_detelages_state")));
	int detelage_num=0;
	int detelage_real_state=0;
	if (strcmp(detelage_state,"on")==0){
		detelage_real_state=DETELAGES_POSITION_ON;
	} else {
		detelage_real_state=DETELAGES_POSITION_OFF;
	}

	if (strcmp(detelage_name,DETELAGES_TXT_DET1)==0){
		detelage_num=DETELAGES_RAIL_DET1;
	} else if (strcmp(detelage_name,DETELAGES_TXT_DET2)==0){
		detelage_num=DETELAGES_RAIL_DET2;
	} else if (strcmp(detelage_name,DETELAGES_TXT_DET3)==0){
		detelage_num=DETELAGES_RAIL_DET3;
	}
	TSKERNEL_MOD_detelages_setPosition(detelage_num,detelage_real_state);
	TSGUI_update(TSKERNEL_THREADSAFE_OFF);
}

void TSGUI_on_cmd_simulButton_pressed(GtkButton *button,gpointer user_data){
	TSKERNEL_runSimul();
}

void TSGUI_on_cmd_realButton_pressed(GtkButton *button,gpointer user_data){
	/*GtkWidget *pQuestion;

	pQuestion = gtk_message_dialog_new (GTK_WINDOW(user_data),GTK_DIALOG_MODAL,GTK_MESSAGE_WARNING,GTK_BUTTONS_YES_NO,"Assurez-vous de la validité de votre programme. Commander le circuit avec un programme érroné peut entraîner des dommages irréversibles au réseau. Etes-vous sûr de continuer?");

	// Affichage et attente d une reponse
	switch(gtk_dialog_run(GTK_DIALOG(pQuestion))){
		case GTK_RESPONSE_YES:
			gtk_widget_destroy(pQuestion);
		break;
		case GTK_RESPONSE_NO:
			gtk_widget_destroy(pQuestion);
			return ;
		break;
	}*/
	TSKERNEL_runReal();
}

void TSGUI_on_cmd_stopButton_pressed(GtkButton *button,gpointer user_data){
	//Stop kernel
	TSKERNEL_stop();
	TSKERNEL_end();
}

gboolean TSGUI_circuitDrawingarea_on_expose_event(GtkWidget *widget,GdkEventExpose *event,gpointer data){
	cairo_t *cr;
	double trains_rgb_r[TRAINS_NB_LOCOMOTIVES]={0.00,0.54,1.00,0.50,1.00,0.12,1.00,0.00};
	double trains_rgb_g[TRAINS_NB_LOCOMOTIVES]={0.54,0.00,0.55,0.00,0.50,0.57,0.84,0.39};
	double trains_rgb_b[TRAINS_NB_LOCOMOTIVES]={0.54,0.54,0.00,0.00,0.45,1.00,0.00,0.00};

	cr = gdk_cairo_create (widget->window);

	cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	cairo_set_line_width(cr, 5);
	cairo_set_line_join(cr,CAIRO_LINE_JOIN_ROUND); 

	int tl_x=160;
	int tl_y=90;

	int tr_x=tl_x+400;
	int tr_y=tl_y;

	int bl_x=tl_x;
	int bl_y=tl_y+200;

	int br_x=tr_x;
	int br_y=bl_y;

	int center_x=tl_x+(tr_x-tl_x)/2;
	int center_y=tl_y+(bl_y-tl_y)/2;

	int offset_signal=10;

	//Block 5
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_B5)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_B5);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_move_to(cr,center_x,center_y); 
	cairo_line_to(cr,tl_x,tl_y);
	cairo_stroke(cr);

	//Block 4
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_B4)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_B4);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_move_to(cr,tl_x,tl_y); 
	cairo_line_to(cr,center_x,tl_y);
	cairo_stroke(cr);

	//Block 10
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_B10)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_B10);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_move_to(cr,center_x,tl_y); 
	cairo_line_to(cr,tr_x,tr_y);
	cairo_stroke(cr);

	//Block 11
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_B11)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_B11);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_move_to(cr,tr_x,tr_y); 
	cairo_line_to(cr,center_x,center_y);
	cairo_stroke(cr);	

	//Block 6
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_B6)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_B6);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_move_to(cr,center_x,center_y); 
	cairo_line_to(cr,bl_x,bl_y);
	cairo_stroke(cr);

	//Block 7
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_B7)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_B7);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_move_to(cr,bl_x,bl_y); 
	cairo_line_to(cr,center_x,bl_y);
	cairo_stroke(cr);

	//Block 13
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_B13)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_B13);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_move_to(cr,center_x,bl_y); 
	cairo_line_to(cr,br_x,br_y);
	cairo_stroke(cr);

	//Block 12
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_B12)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_B12);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_move_to(cr,br_x,br_y); 
	cairo_line_to(cr,center_x,center_y);
	cairo_stroke(cr);

	//Block 2
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_B2)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_B2);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_arc(cr,tl_x,tl_y+(bl_y-tl_y)/2,(bl_y-tl_y)/2,M_PI/2,M_PI);
	cairo_stroke(cr);

	//Block 1
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_B1)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_B1);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_arc(cr,tl_x,tl_y+(bl_y-tl_y)/2,(bl_y-tl_y)/2,M_PI,3*M_PI/2);
	cairo_stroke(cr);

	//Block 15
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_B15)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_B15);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_arc(cr,tr_x,tr_y+(br_y-tr_y)/2,(br_y-tr_y)/2,3*M_PI/2,0);
	cairo_stroke(cr);

	//Block 16
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_B16)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_B16);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_arc(cr,tr_x,tr_y+(br_y-tr_y)/2,(br_y-tr_y)/2,0,M_PI/2);
	cairo_stroke(cr);

	//Block 3
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_B3)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_B3);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_move_to(cr,tl_x,tl_y); 
	cairo_line_to(cr,tl_x+(center_x-tl_x)/5,tl_y-(bl_y-tl_y)/5);
	cairo_move_to(cr,tl_x+(center_x-tl_x)/5,tl_y-(bl_y-tl_y)/5); 
	cairo_line_to(cr,center_x,tl_y-(bl_y-tl_y)/5);
	cairo_stroke(cr);

	//Block 9
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_B9)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_B9);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_move_to(cr,center_x,tl_y-(bl_y-tl_y)/5); 
	cairo_line_to(cr,tr_x-(tr_x-center_x)/5+1,tl_y-(bl_y-tl_y)/5);
	cairo_move_to(cr,tr_x-(tr_x-center_x)/5,tl_y-(bl_y-tl_y)/5); 
	cairo_line_to(cr,tr_x,tr_y);
	cairo_stroke(cr);

	//Block 8
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_B8)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_B8);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_move_to(cr,bl_x,bl_y); 
	cairo_line_to(cr,bl_x+(center_x-bl_x)/5,bl_y+(bl_y-tl_y)/5);
	cairo_move_to(cr,bl_x+(center_x-bl_x)/5,bl_y+(bl_y-tl_y)/5); 
	cairo_line_to(cr,center_x,bl_y+(bl_y-tl_y)/5);
	cairo_stroke(cr);

	//Block 14
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_B14)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_B14);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_move_to(cr,center_x,bl_y+(bl_y-tl_y)/5); 
	cairo_line_to(cr,br_x-(br_x-center_x)/5+1,bl_y+(bl_y-tl_y)/5);
	cairo_move_to(cr,br_x-(br_x-center_x)/5,bl_y+(bl_y-tl_y)/5); 
	cairo_line_to(cr,br_x,br_y);
	cairo_stroke(cr);

	//Garage 2
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_G2)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_G2);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_move_to(cr,bl_x+(center_x-bl_x)/5,bl_y+(bl_y-tl_y)/5); 
	cairo_line_to(cr,bl_x+2*(center_x-bl_x)/5,bl_y+2*(bl_y-tl_y)/5);
	cairo_move_to(cr,bl_x+2*(center_x-bl_x)/5-1,bl_y+2*(bl_y-tl_y)/5); 
	cairo_line_to(cr,br_x+(br_y-tr_y)/2,bl_y+2*(bl_y-tl_y)/5);
	cairo_stroke(cr);

	//Garage 1
	if(TSKERNEL_MOD_blocks_isValidActiveBlock(BLOCKS_G1)==TSKERNEL_NORMAL_EXIT){
		cairo_set_source_rgb(cr, 1, 0, 0);
		int active_train=TSKERNEL_MOD_blocks_getActiveTrain(BLOCKS_G1);
		if (active_train!=TRAINS_LOCOMOTIVE_NOT_ASSIGNED){
			int tid=TSKERNEL_MOD_trains_getOffset(active_train);
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
		} else {
			cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
		}
	} else {
		cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	}
	cairo_arc(cr,tl_x,tl_y+(bl_y-tl_y)/2,(bl_y-tl_y)/2+(bl_y-tl_y)/5,M_PI/2,3*M_PI/2);
	cairo_stroke(cr);
	cairo_move_to(cr,tl_x+(center_x-tl_x)/5,tl_y-(bl_y-tl_y)/5); 
	cairo_line_to(cr,tl_x,tl_y-(bl_y-tl_y)/5);
	cairo_stroke(cr);

	//Signals
	cairo_set_line_cap(cr,CAIRO_LINE_CAP_ROUND);
	//S21
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_21)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,tl_x+5*offset_signal,tl_y+offset_signal);
	cairo_line_to(cr,tl_x+5*offset_signal,tl_y+offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,tl_x+5*offset_signal+5,tl_y+offset_signal+1+3);
  	cairo_show_text(cr, "21"); 

	//S50
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_50)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,center_x-3*offset_signal,tl_y+offset_signal);
	cairo_line_to(cr,center_x-3*offset_signal,tl_y+offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,center_x-3*offset_signal-20,tl_y+offset_signal+1+3);
  	cairo_show_text(cr, "50"); 

	//S51
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_51)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,center_x+3*offset_signal,tl_y-offset_signal);
	cairo_line_to(cr,center_x+3*offset_signal,tl_y-offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,center_x+3*offset_signal+5,tl_y-offset_signal+1+3);
  	cairo_show_text(cr, "51"); 

	//S100
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_100)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,tr_x-5*offset_signal,tl_y-offset_signal);
	cairo_line_to(cr,tr_x-5*offset_signal,tl_y-offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,tr_x-5*offset_signal-25,tl_y-offset_signal+1+3);
  	cairo_show_text(cr, "100"); 

	//S23
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_23)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,tl_x+5*offset_signal,tl_y-(bl_y-tl_y)/5+offset_signal);
	cairo_line_to(cr,tl_x+5*offset_signal,tl_y-(bl_y-tl_y)/5+offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,tl_x+5*offset_signal+5,tl_y-(bl_y-tl_y)/5+offset_signal+1+3);
  	cairo_show_text(cr, "23"); 

	//S49
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_49)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,center_x-3*offset_signal,tl_y-(bl_y-tl_y)/5+offset_signal);
	cairo_line_to(cr,center_x-3*offset_signal,tl_y-(bl_y-tl_y)/5+offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,center_x-3*offset_signal-20,tl_y-(bl_y-tl_y)/5+offset_signal+1+3);
  	cairo_show_text(cr, "49"); 

	//S52
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_52)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,center_x+3*offset_signal,tl_y-(bl_y-tl_y)/5-offset_signal);
	cairo_line_to(cr,center_x+3*offset_signal,tl_y-(bl_y-tl_y)/5-offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,center_x+3*offset_signal+5,tl_y-(bl_y-tl_y)/5-offset_signal+1+3);
  	cairo_show_text(cr, "52"); 

	//S99
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_99)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,tr_x-5*offset_signal,tl_y-(bl_y-tl_y)/5-offset_signal);
	cairo_line_to(cr,tr_x-5*offset_signal,tl_y-(bl_y-tl_y)/5-offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,tr_x-5*offset_signal-20,tl_y-(bl_y-tl_y)/5-offset_signal+1+3);
  	cairo_show_text(cr, "99"); 

	//S35
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_35)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,bl_x+5*offset_signal,bl_y+offset_signal);
	cairo_line_to(cr,bl_x+5*offset_signal,bl_y+offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,bl_x+5*offset_signal+5,bl_y+offset_signal+1+3);
  	cairo_show_text(cr, "35");  

	//S86
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_86)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,center_x-3*offset_signal,bl_y+offset_signal);
	cairo_line_to(cr,center_x-3*offset_signal,bl_y+offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,center_x-3*offset_signal-20,bl_y+offset_signal+1+3);
  	cairo_show_text(cr, "86"); 

	//S87
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_87)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,center_x+3*offset_signal,bl_y-offset_signal);
	cairo_line_to(cr,center_x+3*offset_signal,bl_y-offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,center_x+3*offset_signal+5,bl_y-offset_signal+1+3);
  	cairo_show_text(cr, "87");  

	//S116
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_116)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,br_x-5*offset_signal,bl_y-offset_signal);
	cairo_line_to(cr,br_x-5*offset_signal,bl_y-offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,br_x-5*offset_signal-25,bl_y-offset_signal+1+3);
  	cairo_show_text(cr, "116"); 

	//S34
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_34)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,bl_x+7*offset_signal,bl_y+(bl_y-tl_y)/5+offset_signal);
	cairo_line_to(cr,bl_x+7*offset_signal,bl_y+(bl_y-tl_y)/5+offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,bl_x+7*offset_signal+5,bl_y+(bl_y-tl_y)/5+offset_signal+1+3);
  	cairo_show_text(cr, "34");  

	//S85
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_85)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,center_x-3*offset_signal,bl_y+(bl_y-tl_y)/5+offset_signal);
	cairo_line_to(cr,center_x-3*offset_signal,bl_y+(bl_y-tl_y)/5+offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,center_x-3*offset_signal-20,bl_y+(bl_y-tl_y)/5+offset_signal+1+3);
  	cairo_show_text(cr, "85"); 

	//S88
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_88)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,center_x+3*offset_signal,bl_y+(bl_y-tl_y)/5-offset_signal);
	cairo_line_to(cr,center_x+3*offset_signal,bl_y+(bl_y-tl_y)/5-offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,center_x+3*offset_signal+5,bl_y+(bl_y-tl_y)/5-offset_signal+1+3);
  	cairo_show_text(cr, "88");  

	//S114
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_114)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,br_x-5*offset_signal,bl_y+(bl_y-tl_y)/5-offset_signal);
	cairo_line_to(cr,br_x-5*offset_signal,bl_y+(bl_y-tl_y)/5-offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,br_x-5*offset_signal-25,bl_y+(bl_y-tl_y)/5-offset_signal+1+3);
  	cairo_show_text(cr, "114"); 

	//S33
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_33)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,bl_x+10*offset_signal,bl_y+2*(bl_y-tl_y)/5+offset_signal);
	cairo_line_to(cr,bl_x+10*offset_signal,bl_y+2*(bl_y-tl_y)/5+offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,bl_x+10*offset_signal+5,bl_y+2*(bl_y-tl_y)/5+offset_signal+1+3);
  	cairo_show_text(cr, "33");  

	//S19
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_19)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,tl_x-offset_signal,tl_y-(bl_y-tl_y)/5-offset_signal);
	cairo_line_to(cr,tl_x-offset_signal,tl_y-(bl_y-tl_y)/5-offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,tl_x-offset_signal+5,tl_y-(bl_y-tl_y)/5-offset_signal+1+3);
  	cairo_show_text(cr, "19");  

	//S20
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_20)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,tl_x-2*offset_signal,tl_y-offset_signal);
	cairo_line_to(cr,tl_x-2*offset_signal,tl_y-offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,tl_x-2*offset_signal+5,tl_y-offset_signal+1+3);
  	cairo_show_text(cr, "20"); 

	//S103
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_103)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,tr_x+2*offset_signal,tl_y+offset_signal);
	cairo_line_to(cr,tr_x+2*offset_signal,tl_y+offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,tr_x+2*offset_signal-25,tl_y+offset_signal+1+3);
  	cairo_show_text(cr, "103"); 

	//S118
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_118)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,br_x+2*offset_signal,bl_y+offset_signal);
	cairo_line_to(cr,br_x+2*offset_signal,bl_y+offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,br_x+2*offset_signal+5,bl_y+offset_signal+1+3);
  	cairo_show_text(cr, "118");  

	//S37
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_37)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,bl_x-2*offset_signal,bl_y-offset_signal);
	cairo_line_to(cr,bl_x-2*offset_signal,bl_y-offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,bl_x-2*offset_signal+5,bl_y-offset_signal+1+3);
  	cairo_show_text(cr, "37");

	//S4
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_4)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,tl_x-(bl_y-tl_y)/2-offset_signal,center_y-2*offset_signal);
	cairo_line_to(cr,tl_x-(bl_y-tl_y)/2-offset_signal,center_y-2*offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,tl_x-(bl_y-tl_y)/2-offset_signal-15,center_y-2*offset_signal+1+3);
  	cairo_show_text(cr, "4");

	//S1
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_1)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,tl_x-(bl_y-tl_y)/2+2*offset_signal,center_y+2*offset_signal);
	cairo_line_to(cr,tl_x-(bl_y-tl_y)/2+2*offset_signal,center_y+2*offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,tl_x-(bl_y-tl_y)/2+2*offset_signal+5,center_y+2*offset_signal+1+3);
  	cairo_show_text(cr, "1");

	//S129
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_129)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,tr_x+(bl_y-tl_y)/2+offset_signal,center_y+2*offset_signal);
	cairo_line_to(cr,tr_x+(bl_y-tl_y)/2+offset_signal,center_y+2*offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,tr_x+(bl_y-tl_y)/2+offset_signal+5,center_y+2*offset_signal+1+3);
  	cairo_show_text(cr, "129");

	//S130
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_130)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,tr_x+(bl_y-tl_y)/2-2*offset_signal,center_y-2*offset_signal);
	cairo_line_to(cr,tr_x+(bl_y-tl_y)/2-2*offset_signal,center_y-2*offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,tr_x+(bl_y-tl_y)/2-2*offset_signal-25,center_y-2*offset_signal+1+3);
  	cairo_show_text(cr, "130");

	//S68
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_68)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,center_x-2*offset_signal,center_y-3*offset_signal);
	cairo_line_to(cr,center_x-2*offset_signal,center_y-3*offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,center_x-2*offset_signal+5,center_y-3*offset_signal+3);
  	cairo_show_text(cr, "68");

	//S67
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_67)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,center_x+7*offset_signal,center_y-2*offset_signal);
	cairo_line_to(cr,center_x+7*offset_signal,center_y-2*offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,center_x+7*offset_signal+5,center_y-2*offset_signal+3);
  	cairo_show_text(cr, "67");

	//S65
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_65)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,center_x-7*offset_signal,center_y+2*offset_signal);
	cairo_line_to(cr,center_x-7*offset_signal,center_y+2*offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,center_x-7*offset_signal-20,center_y+2*offset_signal+3);
  	cairo_show_text(cr, "65");

	//S66
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_66)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,center_x+3*offset_signal,center_y+3*offset_signal);
	cairo_line_to(cr,center_x+3*offset_signal,center_y+3*offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,center_x+3*offset_signal-20,center_y+3*offset_signal+3);
  	cairo_show_text(cr, "66");

	//S22
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_22)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,tl_x+5*offset_signal,tl_y+4*offset_signal);
	cairo_line_to(cr,tl_x+5*offset_signal,tl_y+4*offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,tl_x+5*offset_signal-20,tl_y+4*offset_signal+1+3);
  	cairo_show_text(cr, "22");

	//S98
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_98)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,tr_x-7*offset_signal,tl_y+2*offset_signal);
	cairo_line_to(cr,tr_x-7*offset_signal,tl_y+2*offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,tr_x-7*offset_signal-20,tl_y+2*offset_signal+1+3);
  	cairo_show_text(cr, "98");

	//S36
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_36)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,bl_x+6*offset_signal,bl_y-2*offset_signal);
	cairo_line_to(cr,bl_x+6*offset_signal,bl_y-2*offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,bl_x+6*offset_signal+5,bl_y-2*offset_signal+1+3);
  	cairo_show_text(cr, "36");

	//S115
	if(TSKERNEL_MOD_signalisation_getState(SIGNALISATION_NUM_115)==SIGNALISATION_COLOR_GREEN){
		cairo_set_source_rgb(cr, 0, 1, 0);
	} else {
		cairo_set_source_rgb(cr, 1, 0, 0);
	}
	cairo_move_to(cr,br_x-4*offset_signal,br_y-3*offset_signal);
	cairo_line_to(cr,br_x-4*offset_signal,br_y-3*offset_signal+1);
	cairo_stroke(cr);
	cairo_move_to(cr,br_x-4*offset_signal+5,br_y-3*offset_signal+1+3);
  	cairo_show_text(cr, "115");


	//Aiguillages
	cairo_set_source_rgb(cr, 0, 0, 1);
	//D1
	cairo_move_to(cr,tl_x,tl_y+2*offset_signal);
  	cairo_show_text(cr, "D1");	
	if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D1_1)==AIGUILLAGES_POSITION_2 && TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D1_2)==AIGUILLAGES_POSITION_2){//gauche
		cairo_move_to(cr,tl_x,tl_y); 
		cairo_line_to(cr,(tl_x+(tl_x+(center_x-tl_x)/5))/2,(tl_y+(tl_y-(bl_y-tl_y)/5))/2);
		cairo_stroke(cr);
	} else if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D1_1)==AIGUILLAGES_POSITION_1 && TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D1_2)==AIGUILLAGES_POSITION_2){//centre
		cairo_move_to(cr,tl_x,tl_y); 
		cairo_line_to(cr,tl_x+(center_x-tl_x)/6,tl_y);
		cairo_stroke(cr);
	}else if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D1_1)==AIGUILLAGES_POSITION_1 && TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D1_2)==AIGUILLAGES_POSITION_1){//droite
		cairo_move_to(cr,tl_x,tl_y); 
		cairo_line_to(cr,(tl_x+(tl_x+(tl_x+center_x)/2)/2)/2,(tl_y+(tl_y+(tl_y+center_y)/2)/2)/2);
		cairo_stroke(cr);
	}

	//D2
	cairo_move_to(cr,bl_x,bl_y-2*offset_signal);
  	cairo_show_text(cr, "D2");
	if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D2_1)==AIGUILLAGES_POSITION_2 && TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D2_2)==AIGUILLAGES_POSITION_2){//gauche	
		cairo_move_to(cr,bl_x,bl_y); 
		cairo_line_to(cr,(bl_x+(bl_x+(bl_x+center_x)/2)/2)/2,(bl_y+(bl_y+(bl_y+center_y)/2)/2)/2);
		cairo_stroke(cr);
	} else if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D2_1)==AIGUILLAGES_POSITION_1 && TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D2_2)==AIGUILLAGES_POSITION_2){//centre
		cairo_move_to(cr,bl_x,bl_y); 
		cairo_line_to(cr,bl_x+(center_x-bl_x)/6,bl_y);
		cairo_stroke(cr);
	}else if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D2_1)==AIGUILLAGES_POSITION_1 && TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D2_2)==AIGUILLAGES_POSITION_1){//droite
		cairo_move_to(cr,bl_x,bl_y); 
		cairo_line_to(cr,(bl_x+(bl_x+(center_x-bl_x)/5))/2,(bl_y+(bl_y+(bl_y-tl_y)/5))/2);
		cairo_stroke(cr);
	}

	//D3
	cairo_move_to(cr,tr_x,tr_y-2*offset_signal);
  	cairo_show_text(cr, "D3");
	if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D3_1)==AIGUILLAGES_POSITION_2 && TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D3_2)==AIGUILLAGES_POSITION_2){//gauche
		cairo_move_to(cr,tr_x,tr_y); 
		cairo_line_to(cr,(tr_x+(tr_x+(tr_x+center_x)/2)/2)/2,(tr_y+(tr_y+(tr_y+center_y)/2)/2)/2);
		cairo_stroke(cr);
	} else if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D3_1)==AIGUILLAGES_POSITION_1 && TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D3_2)==AIGUILLAGES_POSITION_2){//centre
		cairo_move_to(cr,tr_x,tr_y); 
		cairo_line_to(cr,tr_x-(tr_x-center_x)/6,tr_y);
		cairo_stroke(cr);
	}else if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D3_1)==AIGUILLAGES_POSITION_1 && TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D3_2)==AIGUILLAGES_POSITION_1){//droite
		cairo_move_to(cr,tr_x,tr_y); 
		cairo_line_to(cr,(tr_x+(tr_x-(tr_x-center_x)/5))/2,(tr_y+(tr_y-(br_y-tr_y)/5))/2);
		cairo_stroke(cr);
	}

	//D4
	cairo_move_to(cr,br_x,br_y-2*offset_signal);
  	cairo_show_text(cr, "D4");
	if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D4_1)==AIGUILLAGES_POSITION_2 && TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D4_2)==AIGUILLAGES_POSITION_2){//gauche	
		cairo_move_to(cr,br_x,br_y); 
		cairo_line_to(cr,(br_x+(br_x-(br_x-center_x)/5))/2,(br_y+(br_y+(br_y-tr_y)/5))/2);
		cairo_stroke(cr);
	} else if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D4_1)==AIGUILLAGES_POSITION_1 && TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D4_2)==AIGUILLAGES_POSITION_2){//centre
		cairo_move_to(cr,br_x,br_y); 
		cairo_line_to(cr,br_x-(br_x-center_x)/6,br_y);
		cairo_stroke(cr);
	}else if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D4_1)==AIGUILLAGES_POSITION_1 && TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_D4_2)==AIGUILLAGES_POSITION_1){//droite
		cairo_move_to(cr,br_x,br_y); 
		cairo_line_to(cr,(br_x+(br_x+(br_x+center_x)/2)/2)/2,(br_y+(br_y+(br_y+center_y)/2)/2)/2);
		cairo_stroke(cr);
	}

	//X1
	cairo_move_to(cr,center_x,center_y+2*offset_signal);
  	cairo_show_text(cr,"X1");
	if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_CROISEMENT)==AIGUILLAGES_CROISEMENT_POSITION_BIFURCATION){//bifurcation
		cairo_move_to(cr,center_x-10,center_y-5); 
		cairo_line_to(cr,center_x+10,center_y-5);
		cairo_move_to(cr,center_x-10,center_y+5); 
		cairo_line_to(cr,center_x+10,center_y+5);
		cairo_stroke(cr);
		cairo_set_source_rgb(cr,1, 1, 1);
		cairo_move_to(cr,center_x-10,center_y); 
		cairo_line_to(cr,center_x+10,center_y);
		cairo_stroke(cr);
		cairo_set_source_rgb(cr, 0, 0, 1);
	} else if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_CROISEMENT)==AIGUILLAGES_CROISEMENT_POSITION_CROISEMENT){//croisement
		cairo_move_to(cr,center_x-10,center_y-5); 
		cairo_line_to(cr,center_x+10,center_y+5);
		cairo_move_to(cr,center_x+10,center_y-5); 
		cairo_line_to(cr,center_x-10,center_y+5);
		cairo_stroke(cr);
	}

	//S1
	cairo_move_to(cr, tl_x+(center_x-tl_x)/5,tl_y-(bl_y-tl_y)/5-offset_signal);
	cairo_show_text(cr, "S1");
	if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_S1)==AIGUILLAGES_POSITION_1){//deviation	
		cairo_move_to(cr,(tl_x+(tl_x+(center_x-tl_x)/5))/2,(tl_y+(tl_y-(bl_y-tl_y)/5))/2); 
		cairo_line_to(cr,tl_x+(center_x-tl_x)/5,tl_y-(bl_y-tl_y)/5);
		cairo_stroke(cr);
	} else if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_S1)==AIGUILLAGES_POSITION_2){//centre
		cairo_move_to(cr,tl_x+(center_x-tl_x)/5,tl_y-(bl_y-tl_y)/5); 
		cairo_line_to(cr,tl_x+15,tl_y-(bl_y-tl_y)/5);
		cairo_stroke(cr);
	}

	//S2
	cairo_move_to(cr, bl_x+(center_x-bl_x)/5-2*offset_signal,bl_y+(bl_y-tl_y)/5+2*offset_signal);
	cairo_show_text(cr, "S2");
	if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_S2)==AIGUILLAGES_POSITION_2){//deviation	
		cairo_move_to(cr,bl_x+(center_x-bl_x)/5,bl_y+(bl_y-tl_y)/5); 
		cairo_line_to(cr,((bl_x+(center_x-bl_x)/5)+(bl_x+2*(center_x-bl_x)/5))/2,((bl_y+(bl_y-tl_y)/5)+(bl_y+2*(bl_y-tl_y)/5))/2);
		cairo_stroke(cr);
	} else if (TSKERNEL_MOD_aiguillages_getPosition(AIGUILLAGES_AIGUILLAGE_S2)==AIGUILLAGES_POSITION_1){//centre
		cairo_move_to(cr,bl_x+(center_x-bl_x)/5,bl_y+(bl_y-tl_y)/5); 
		cairo_line_to(cr,(bl_x+(center_x-bl_x)/5+(bl_x+(center_x-bl_x)/5+center_x)/2)/2-15,bl_y+(bl_y-tl_y)/5);
		cairo_stroke(cr);
	}


	//Rails de detelage
	cairo_set_line_width(cr,7);
	cairo_set_line_join(cr,CAIRO_LINE_CAP_BUTT);

	//DET1
	if(TSKERNEL_MOD_detelages_getPosition(DETELAGES_RAIL_DET1)==DETELAGES_POSITION_OFF){
		cairo_set_source_rgb(cr, 1, 0, 0);
	} else {
		cairo_set_source_rgb(cr, 0, 1, 0);
	}
	cairo_move_to(cr,tl_x-((bl_y-tl_y)/2+(bl_y-tl_y)/5),center_y-10);
	cairo_line_to(cr,tl_x-((bl_y-tl_y)/2+(bl_y-tl_y)/5),center_y+10);
	cairo_stroke(cr);
	cairo_move_to(cr,tl_x-((bl_y-tl_y)/2+(bl_y-tl_y)/5)+offset_signal/2,center_y+5);
	cairo_show_text(cr, "DET1");

	//DET2
	if(TSKERNEL_MOD_detelages_getPosition(DETELAGES_RAIL_DET2)==DETELAGES_POSITION_OFF){
		cairo_set_source_rgb(cr, 1, 0, 0);
	} else {
		cairo_set_source_rgb(cr, 0, 1, 0);
	}
	cairo_move_to(cr,center_x,bl_y);
	cairo_line_to(cr,center_x+20,br_y);
	cairo_stroke(cr);
	cairo_move_to(cr,center_x-5,bl_y-offset_signal);
	cairo_show_text(cr, "DET2");
	
	//DET3
	if(TSKERNEL_MOD_detelages_getPosition(DETELAGES_RAIL_DET3)==DETELAGES_POSITION_OFF){
		cairo_set_source_rgb(cr, 1, 0, 0);
	} else {
		cairo_set_source_rgb(cr, 0, 1, 0);
	}
	cairo_move_to(cr,center_x+(bl_y-tl_y)/5,bl_y+2*(bl_y-tl_y)/5);
	cairo_line_to(cr,center_x+(bl_y-tl_y)/5+20,bl_y+2*(bl_y-tl_y)/5);
	cairo_stroke(cr);
	cairo_move_to(cr,center_x+(bl_y-tl_y)/5-5,bl_y+2*(bl_y-tl_y)/5-offset_signal);
	cairo_show_text(cr, "DET3");

	//Blocks text
	cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);
	cairo_move_to(cr,(tl_x+center_x)/2,tl_y-offset_signal);
	cairo_show_text(cr, "B4");
	cairo_move_to(cr,(tr_x+center_x)/2,tl_y-offset_signal);
	cairo_show_text(cr, "B10");
	cairo_move_to(cr,(tl_x+center_x)/2,tl_y-(bl_y-tl_y)/5-offset_signal);
	cairo_show_text(cr, "B3");
	cairo_move_to(cr,(tr_x+center_x)/2,tl_y-(bl_y-tl_y)/5-offset_signal);
	cairo_show_text(cr, "B9");
	cairo_move_to(cr,(bl_x+center_x)/2,bl_y-offset_signal);
	cairo_show_text(cr, "B7");
	cairo_move_to(cr,(br_x+center_x)/2,bl_y-offset_signal);
	cairo_show_text(cr, "B13");
	cairo_move_to(cr,(bl_x+center_x)/2,bl_y+(bl_y-tl_y)/5-offset_signal);
	cairo_show_text(cr, "B8");
	cairo_move_to(cr,(br_x+center_x)/2,bl_y+(bl_y-tl_y)/5-offset_signal);
	cairo_show_text(cr, "B14");
	cairo_move_to(cr,center_x,bl_y+2*(bl_y-tl_y)/5-offset_signal);
	cairo_show_text(cr, "G2");
	cairo_move_to(cr,(tl_x+center_x)/2,(tl_y+center_y)/2+2*offset_signal);
	cairo_show_text(cr, "B5");
	cairo_move_to(cr,(tr_x+center_x)/2,(tr_y+center_y)/2+2*offset_signal);
	cairo_show_text(cr, "B11");
	cairo_move_to(cr,(bl_x+center_x)/2-offset_signal,(bl_y+center_y)/2-offset_signal);
	cairo_show_text(cr, "B6");
	cairo_move_to(cr,(br_x+center_x)/2,(br_y+center_y)/2-offset_signal);
	cairo_show_text(cr, "B12");
	cairo_move_to(cr,br_x+((br_y-tr_y)/2)*2/3-3*offset_signal,(tr_y+center_y)/2-offset_signal);
	cairo_show_text(cr, "B15");
	cairo_move_to(cr,br_x+((br_y-tr_y)/2)*2/3-3*offset_signal,(br_y+center_y)/2+2*offset_signal);
	cairo_show_text(cr, "B16");
	cairo_move_to(cr,tl_x-((br_y-tr_y)/2)*2/3+offset_signal,(tl_y+center_y)/2-offset_signal);
	cairo_show_text(cr, "B1");
	cairo_move_to(cr,tl_x-((br_y-tr_y)/2)*2/3+offset_signal,(bl_y+center_y)/2+2*offset_signal);
	cairo_show_text(cr, "B2");
	cairo_move_to(cr,tl_x-((br_y-tr_y)/2)*2/3-2*offset_signal,tl_y-(bl_y-tl_y)/5+offset_signal);
	cairo_show_text(cr, "G1");

	//Trains text
	int tid=0;
	int tid_x=0;
	int tid_y=0;
	for(tid=0;tid<TRAINS_NB_LOCOMOTIVES;tid++){
		int train_num=TRAINS_NUMS[tid];
		//if (TSKERNEL_MOD_trains_isActive(train_num)==TSKERNEL_NORMAL_EXIT){
			cairo_set_source_rgb(cr,trains_rgb_r[tid],trains_rgb_g[tid],trains_rgb_b[tid]);
			cairo_move_to(cr,tl_x-((bl_y-tl_y)/2+(bl_y-tl_y)/5)+tid_x*23*offset_signal,bl_y+2*(bl_y-tl_y)/5+4*offset_signal+tid_y*offset_signal);
			char* message=(char*)malloc(1024*sizeof(char));
			sprintf(message,"Train %d : vitesse=%d, bloc=%d",train_num,TSKERNEL_MOD_trains_getSpeed(train_num),TSKERNEL_MOD_trains_getPosition(train_num));
			cairo_show_text(cr,message);
			free(message);
			tid_y++;
		//}
		if (tid_y==3){
			tid_y=0;
			tid_x++;
		}
	}
	cairo_set_source_rgb(cr, 0.69, 0.69, 0.69);

	cairo_destroy(cr);

	return FALSE;
}

