/*------------------------------------------------------------------------------
** Projet : trainsim                                                         
** Auteurs : Vincent BONESTEVE, Dominique PADIOU                           
** Module : gui                                                    
** Fichier : gui_callbacks.h
** Description : callbacks boutons gui                          
------------------------------------------------------------------------------*/
/**
 * \file gui_callbacks.h
 * \brief Module : gui, Callbacks des boutons de la gui 
 * \author Vincent BONESTEVE, Dominique PADIOU 
 * \version 1.0-stable
 * \date 01/01/2010
 */
#ifndef GUI_CALLBACKS_H
#define GUI_CALLBACKS_H
#include <gtk/gtk.h>
#include "gui_interface.h"
#include "gui_support.h"
#include "const_signalisation.h"
#include "const_aiguillages.h"
#include "const_receptivities.h"
#include "const_trains.h"
#include "const_detelages.h"
#include "const_blocks.h"
#include "const_kernel.h"

/**
 * \fn void TSGUI_on_quitter1_activate(GtkMenuItem *menuitem,gpointer user_data)
 * \brief Callback de menu
 * \param menuitem element de menu
 * \param user_data donnees utilisateur
 * \return void
 */
void TSGUI_on_quitter1_activate(GtkMenuItem *menuitem,gpointer user_data);
/**
 * \fn gboolean TSGUI_on_Quit(GtkWidget *pWindow, GdkEvent *pEvent,gpointer data)
 * \brief Callback de sortie
 * \param pWindow widget
 * \param pEvent evenement
 * \param data donnees utilisateur
 * \return gboolean code etat
 */
gboolean TSGUI_on_Quit(GtkWidget *pWindow, GdkEvent *pEvent,gpointer data);
/**
 * \fn void TSGUI_on_about1_activate(GtkMenuItem *menuitem,gpointer user_data)
 * \brief Callback de menu
 * \param menuitem element de menu
 * \param user_data donnees utilisateur
 * \return void
 */
void TSGUI_on_about1_activate(GtkMenuItem *menuitem,gpointer user_data);
/**
 * \fn void TSGUI_on_signalisationbutton_pressed(GtkButton *button,gpointer user_data)
 * \brief Callback de bouton
 * \param button bouton
 * \param user_data donnees utilisateur
 * \return void
 */
void TSGUI_on_signalisationbutton_pressed(GtkButton *button,gpointer user_data);
/**
 * \fn void TSGUI_on_aiguillagesButton_pressed(GtkButton *button,gpointer user_data)
 * \brief Callback de bouton
 * \param button bouton
 * \param user_data donnees utilisateur
 * \return void
 */
void TSGUI_on_aiguillagesButton_pressed(GtkButton *button,gpointer user_data);
/**
 * \fn void TSGUI_on_receptivitiesButton_pressed(GtkButton *button,gpointer user_data)
 * \brief Callback de bouton
 * \param button bouton
 * \param user_data donnees utilisateur
 * \return void
 */
void TSGUI_on_receptivitiesButton_pressed(GtkButton *button,gpointer user_data);
/**
 * \fn void TSGUI_on_trains_invButton_pressed(GtkButton *button,gpointer user_data)
 * \brief Callback de bouton
 * \param button bouton
 * \param user_data donnees utilisateur
 * \return void
 */
void TSGUI_on_trains_invButton_pressed(GtkButton *button,gpointer user_data);
/**
 * \fn void TSGUI_on_trainsButton_pressed(GtkButton *button,gpointer user_data)
 * \brief Callback de bouton
 * \param button bouton
 * \param user_data donnees utilisateur
 * \return void
 */
void TSGUI_on_trainsButton_pressed(GtkButton *button,gpointer user_data);
/**
 * \fn void TSGUI_on_detelagesButton_pressed(GtkButton *button,gpointer user_data)
 * \brief Callback de bouton
 * \param button bouton
 * \param user_data donnees utilisateur
 * \return void
 */
void TSGUI_on_detelagesButton_pressed(GtkButton *button,gpointer user_data);
/**
 * \fn void TSGUI_on_cmd_simulButton_pressed(GtkButton *button,gpointer user_data)
 * \brief Callback de bouton
 * \param button bouton
 * \param user_data donnees utilisateur
 * \return void
 */
void TSGUI_on_cmd_simulButton_pressed(GtkButton *button,gpointer user_data);
/**
 * \fn void TSGUI_on_cmd_realButton_pressed(GtkButton *button,gpointer user_data)
 * \brief Callback de bouton
 * \param button bouton
 * \param user_data donnees utilisateur
 * \return void
 */
void TSGUI_on_cmd_realButton_pressed(GtkButton *button,gpointer user_data);
/**
 * \fn void TSGUI_on_cmd_stopButton_pressed(GtkButton *button,gpointer user_data)
 * \brief Callback de bouton
 * \param button bouton
 * \param user_data donnees utilisateur
 * \return void
 */
void TSGUI_on_cmd_stopButton_pressed(GtkButton *button,gpointer user_data);
/**
 * \fn gboolean TSGUI_circuitDrawingarea_on_expose_event(GtkWidget *widget,GdkEventExpose *event,gpointer data)
 * \brief Callback de dessin
 * \param widget widget
 * \param event evenement
 * \param data donnees utilisateur
 * \return gboolean code etat
 */
gboolean TSGUI_circuitDrawingarea_on_expose_event(GtkWidget *widget,GdkEventExpose *event,gpointer data);

#endif
