/*------------------------------------------------------------------------------
** Projet : trainsim                                                         
** Auteurs : Vincent BONESTEVE, Dominique PADIOU                           
** Module : gui                                                    
** Fichier : gui_interface.c
** Description : gui widgets
------------------------------------------------------------------------------*/
/**
 * \file gui_interface.c
 * \brief Module : gui, Widgets de l'Interface graphique
 * \author Vincent BONESTEVE, Dominique PADIOU 
 * \version 1.0-stable
 * \date 01/01/2010
 */
#include "gui_interface.h"


GtkWidget* TSGUI_create_mainWindow (void){
  GtkWidget *TSGUI_mainWindow;
  GtkWidget *TSGUI_mainContentDivider;
  GtkWidget *TSGUI_menuBar;
  GtkWidget *TSGUI_menuitem1;
  GtkWidget *TSGUI_menuitem1_menu;
  GtkWidget *TSGUI_quitter1;
  GtkWidget *TSGUI_imageQuitter;
  GtkWidget *TSGUI_menuitem4;
  GtkWidget *TSGUI_menuitem4_menu;
  GtkWidget *TSGUI_about1;
  GtkWidget *TSGUI_mainHbox;
  GtkWidget *TSGUI_leftVbox;
  GtkWidget *TSGUI_circuitDrawingarea;
  GtkWidget *TSGUI_logScrolledwindow;
  GtkWidget *TSGUI_logTextView;
  GtkWidget *TSGUI_mainVseparator;
  GtkWidget *TSGUI_rightVbox;
  GtkWidget *TSGUI_signalisationVbox;
  GtkWidget *TSGUI_signalisationLabel;
  GtkWidget *TSGUI_signalisationHbox;
  GtkWidget *TSGUI_signal_numLabel;
  GtkWidget *TSGUI_signal_num;
  GtkWidget *TSGUI_signal_colorLabel;
  GtkWidget *TSGUI_signal_color;
  GtkWidget *TSGUI_signalisationButton;
  GtkWidget *image1;
  GtkWidget *TSGUI_hseparator1;
  GtkWidget *TSGUI_aiguillagesVbox;
  GtkWidget *TSGUI_aiguillagesLabel;
  GtkWidget *TSGUI_aiguillagesHbox;
  GtkWidget *TSGUI_aiguillage_numLabel;
  GtkWidget *TSGUI_aiguillage_num;
  GtkWidget *TSGUI_aiguillage_posLabel;
  GtkWidget *TSGUI_aiguillage_pos;
  GtkWidget *TSGUI_aiguillagesButton;
  GtkWidget *image2;
  GtkWidget *TSGUI_hseparator2;
  GtkWidget *TSGUI_receptivitiesVbox;
  GtkWidget *TSGUI_receptivitesLabel;
  GtkWidget *TSGUI_receptivitiesHbox;
  GtkWidget *TSGUI_receptivities_octetLabel;
  GtkWidget *TSGUI_receptivities_octet;
  GtkWidget *TSGUI_receptivities_bitLabel;
  GtkWidget *TSGUI_receptivities_bit;
  GtkWidget *TSGUI_receptivitiesButton;
  GtkWidget *image3;
  GtkWidget *TSGUI_receptivitiesHbox2;
  GtkWidget *TSGUI_receptivities_valueLabel;
  GtkWidget *TSGUI_receptivities_value;
  GtkWidget *TSGUI_hseparator3;
  GtkWidget *TSGUI_trainsVbox;
  GtkWidget *TSGUI_trainsLabel;
  GtkWidget *TSGUI_trainsHbox;
  GtkWidget *TSGUI_trains_numLabel;
  GtkWidget *TSGUI_trains_num;
  GtkWidget *TSGUI_trains_fctLabel;
  GtkWidget *TSGUI_trains_fct;
  GtkWidget *TSGUI_trains_invButton;
  GtkWidget *alignment1;
  GtkWidget *hbox8;
  GtkWidget *image4;
  GtkWidget *label15;
  GtkWidget *TSGUI_trainsHbox2;
  GtkWidget *TSGUI_trains_speedLabel;
  GtkWidget *TSGUI_trains_speed;
  GtkWidget *TSGUI_trainsButton;
  GtkWidget *image5;
  GtkWidget *TSGUI_hseparator4;
  GtkWidget *TSGUI_detelagesVbox;
  GtkWidget *TSGUI_detelagesLabel;
  GtkWidget *TSGUI_detelagesHbox;
  GtkWidget *TSGUI_detelages_numLabel;
  GtkWidget *TSGUI_detelages_num;
  GtkWidget *TSGUI_detelages_stateLabel;
  GtkWidget *TSGUI_detelages_state;
  GtkWidget *TSGUI_detelagesButton;
  GtkWidget *image10;
  GtkWidget *hseparator6;
  GtkWidget *TSGUI_cmdVbox;
  GtkWidget *TSGUI_cmdLabel;
  GtkWidget *TSGUI_cmd_simulButton;
  GtkWidget *alignment3;
  GtkWidget *hbox11;
  GtkWidget *image7;
  GtkWidget *label18;
  GtkWidget *TSGUI_cmd_realButton;
  GtkWidget *alignment4;
  GtkWidget *hbox12;
  GtkWidget *image8;
  GtkWidget *label19;
  GtkWidget *TSGUI_cmd_stopButton;
  GtkWidget *alignment5;
  GtkWidget *hbox13;
  GtkWidget *image9;
  GtkWidget *label20;
  GtkWidget *TSGUI_hseparator5;
  GtkWidget *TSGUI_statusBar;
  GtkAccelGroup *accel_group;
  int i=0;
  char* txt;

  accel_group = gtk_accel_group_new ();

  TSGUI_mainWindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request (TSGUI_mainWindow, 1000, 700);
  gtk_window_set_title (GTK_WINDOW (TSGUI_mainWindow), _("TrainSim"));
  gtk_window_set_position (GTK_WINDOW (TSGUI_mainWindow), GTK_WIN_POS_CENTER);
  gtk_window_set_default_size (GTK_WINDOW (TSGUI_mainWindow), 800, 600);

  TSGUI_mainContentDivider = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (TSGUI_mainContentDivider);
  gtk_container_add (GTK_CONTAINER (TSGUI_mainWindow), TSGUI_mainContentDivider);

  TSGUI_menuBar = gtk_menu_bar_new ();
  gtk_widget_show (TSGUI_menuBar);
  gtk_box_pack_start (GTK_BOX (TSGUI_mainContentDivider), TSGUI_menuBar, FALSE, FALSE, 0);

  TSGUI_menuitem1 = gtk_menu_item_new_with_mnemonic (_("_Fichier"));
  gtk_widget_show (TSGUI_menuitem1);
  gtk_container_add (GTK_CONTAINER (TSGUI_menuBar), TSGUI_menuitem1);

  TSGUI_menuitem1_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (TSGUI_menuitem1), TSGUI_menuitem1_menu);

  TSGUI_quitter1 = gtk_image_menu_item_new_with_mnemonic (_("_Quitter"));
  gtk_widget_show (TSGUI_quitter1);
  gtk_container_add (GTK_CONTAINER (TSGUI_menuitem1_menu), TSGUI_quitter1);
  gtk_widget_add_accelerator (TSGUI_quitter1, "activate", accel_group,
                              GDK_F4, (GdkModifierType) GDK_MOD1_MASK,
                              GTK_ACCEL_VISIBLE);

  TSGUI_imageQuitter = gtk_image_new_from_stock ("gtk-quit", GTK_ICON_SIZE_MENU);
  gtk_widget_show (TSGUI_imageQuitter);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (TSGUI_quitter1), TSGUI_imageQuitter);

  TSGUI_menuitem4 = gtk_menu_item_new_with_mnemonic (_("_Aide"));
  gtk_widget_show (TSGUI_menuitem4);
  gtk_container_add (GTK_CONTAINER (TSGUI_menuBar), TSGUI_menuitem4);

  TSGUI_menuitem4_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (TSGUI_menuitem4), TSGUI_menuitem4_menu);

  TSGUI_about1 = gtk_menu_item_new_with_mnemonic (_("_A propos"));
  gtk_widget_show (TSGUI_about1);
  gtk_container_add (GTK_CONTAINER (TSGUI_menuitem4_menu), TSGUI_about1);

  TSGUI_mainHbox = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (TSGUI_mainHbox);
  gtk_box_pack_start (GTK_BOX (TSGUI_mainContentDivider), TSGUI_mainHbox, TRUE, TRUE, 0);

  TSGUI_leftVbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (TSGUI_leftVbox);
  gtk_box_pack_start (GTK_BOX (TSGUI_mainHbox), TSGUI_leftVbox, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_leftVbox, 525, -1);

  TSGUI_circuitDrawingarea = gtk_drawing_area_new ();
  gtk_widget_show (TSGUI_circuitDrawingarea);
  gtk_box_pack_start (GTK_BOX (TSGUI_leftVbox), TSGUI_circuitDrawingarea, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_circuitDrawingarea, 505, 232);

  TSGUI_logScrolledwindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (TSGUI_logScrolledwindow);
  gtk_box_pack_start (GTK_BOX (TSGUI_leftVbox), TSGUI_logScrolledwindow, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_logScrolledwindow, -1, 5);
  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (TSGUI_logScrolledwindow), GTK_SHADOW_IN);
 
  GtkTextIter iter; 
  GdkColor color;
  TSGUI_logTextView = gtk_text_view_new ();
  gtk_widget_show (TSGUI_logTextView);
  gtk_container_add (GTK_CONTAINER (TSGUI_logScrolledwindow), TSGUI_logTextView);
  gtk_text_view_set_editable (GTK_TEXT_VIEW (TSGUI_logTextView), FALSE);
  gtk_text_view_set_cursor_visible (GTK_TEXT_VIEW (TSGUI_logTextView), FALSE);
  gtk_text_view_set_justification (GTK_TEXT_VIEW (TSGUI_logTextView), GTK_JUSTIFY_LEFT); 
  gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (TSGUI_logTextView), GTK_WRAP_WORD); 
  GtkTextBuffer* TSGUI_logTextView_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (TSGUI_logTextView)); 
  gdk_color_parse ("white", &color); 
  gtk_text_buffer_create_tag (TSGUI_logTextView_buffer, "foreground_white", "foreground-gdk", &color, NULL); 
  gdk_color_parse ("red", &color); 
  gtk_text_buffer_create_tag (TSGUI_logTextView_buffer, "background_red", "background-gdk", &color, NULL);
  gdk_color_parse ("blue", &color); 
  gtk_text_buffer_create_tag (TSGUI_logTextView_buffer, "background_blue", "background-gdk", &color, NULL);

  gtk_text_buffer_create_tag (TSGUI_logTextView_buffer, "style_italic", "style", PANGO_STYLE_ITALIC, NULL); 
  gtk_text_buffer_create_tag (TSGUI_logTextView_buffer, "weight_bold", "weight", PANGO_WEIGHT_BOLD, NULL); 
  gtk_text_buffer_create_tag (TSGUI_logTextView_buffer, "size_medium", "scale", PANGO_SCALE_MEDIUM, NULL); 
  gtk_text_buffer_create_tag (TSGUI_logTextView_buffer, "size_large", "scale", PANGO_SCALE_LARGE, NULL);


  TSGUI_mainVseparator = gtk_vseparator_new ();
  gtk_widget_show (TSGUI_mainVseparator);
  gtk_box_pack_start (GTK_BOX (TSGUI_mainHbox), TSGUI_mainVseparator, FALSE, FALSE, 0);

  TSGUI_rightVbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (TSGUI_rightVbox);
  gtk_box_pack_start (GTK_BOX (TSGUI_mainHbox), TSGUI_rightVbox, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_rightVbox, 130, -1);
  gtk_container_set_border_width (GTK_CONTAINER (TSGUI_rightVbox), 11);

  TSGUI_signalisationVbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (TSGUI_signalisationVbox);
  gtk_box_pack_start (GTK_BOX (TSGUI_rightVbox), TSGUI_signalisationVbox, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_signalisationVbox, 130, -1);

  TSGUI_signalisationLabel = gtk_label_new (_("Signalisation"));
  gtk_widget_show (TSGUI_signalisationLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_signalisationVbox), TSGUI_signalisationLabel, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_signalisationLabel, 44, 17);

  TSGUI_signalisationHbox = gtk_hbox_new (FALSE, 4);
  gtk_widget_show (TSGUI_signalisationHbox);
  gtk_box_pack_start (GTK_BOX (TSGUI_signalisationVbox), TSGUI_signalisationHbox, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_signalisationHbox, 130, 15);

  TSGUI_signal_numLabel = gtk_label_new (_("Num"));
  gtk_widget_show (TSGUI_signal_numLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_signalisationHbox), TSGUI_signal_numLabel, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_signal_numLabel, 31, 15);

  TSGUI_signal_num = gtk_combo_box_entry_new_text ();
  gtk_widget_show (TSGUI_signal_num);
  gtk_box_pack_start (GTK_BOX (TSGUI_signalisationHbox), TSGUI_signal_num, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_signal_num, 44, 15);
  for(i=0;i<SIGNALISATION_NB_SIGNAUX;i++){
	txt=(char*) malloc(100*sizeof(char));
	sprintf(txt,"%d",SIGNALISATION_NUMS[i]);
  	gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_signal_num),(gchar*) txt);
	free(txt);
  }

  TSGUI_signal_colorLabel = gtk_label_new (_("Couleur"));
  gtk_widget_show (TSGUI_signal_colorLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_signalisationHbox), TSGUI_signal_colorLabel, FALSE, FALSE, 0);

  TSGUI_signal_color = gtk_combo_box_entry_new_text ();
  gtk_widget_show (TSGUI_signal_color);
  gtk_box_pack_start (GTK_BOX (TSGUI_signalisationHbox), TSGUI_signal_color, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_signal_color, 50, 15);
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_signal_color),_("rouge"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_signal_color),_("vert"));

  TSGUI_signalisationButton = gtk_button_new ();
  gtk_widget_show (TSGUI_signalisationButton);
  gtk_box_pack_start (GTK_BOX (TSGUI_signalisationHbox), TSGUI_signalisationButton, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_signalisationButton, 30, 15);

  image1 = gtk_image_new_from_stock ("gtk-ok", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image1);
  gtk_container_add (GTK_CONTAINER (TSGUI_signalisationButton), image1);

  TSGUI_hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (TSGUI_hseparator1);
  gtk_box_pack_start (GTK_BOX (TSGUI_signalisationVbox), TSGUI_hseparator1, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_hseparator1, -1, 20);

  TSGUI_aiguillagesVbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (TSGUI_aiguillagesVbox);
  gtk_box_pack_start (GTK_BOX (TSGUI_rightVbox), TSGUI_aiguillagesVbox, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_aiguillagesVbox, 130, -1);

  TSGUI_aiguillagesLabel = gtk_label_new (_("Aiguillages"));
  gtk_widget_show (TSGUI_aiguillagesLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_aiguillagesVbox), TSGUI_aiguillagesLabel, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_aiguillagesLabel, 44, 17);

  TSGUI_aiguillagesHbox = gtk_hbox_new (FALSE, 4);
  gtk_widget_show (TSGUI_aiguillagesHbox);
  gtk_box_pack_start (GTK_BOX (TSGUI_aiguillagesVbox), TSGUI_aiguillagesHbox, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_aiguillagesHbox, 130, 15);

  TSGUI_aiguillage_numLabel = gtk_label_new (_("Num"));
  gtk_widget_show (TSGUI_aiguillage_numLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_aiguillagesHbox), TSGUI_aiguillage_numLabel, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_aiguillage_numLabel, 31, 15);

  TSGUI_aiguillage_num = gtk_combo_box_entry_new_text ();
  gtk_widget_show (TSGUI_aiguillage_num);
  gtk_box_pack_start (GTK_BOX (TSGUI_aiguillagesHbox), TSGUI_aiguillage_num, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_aiguillage_num, 176, 15);
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_aiguillage_num),_("S1"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_aiguillage_num),_("S2"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_aiguillage_num),_("D1"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_aiguillage_num),_("D2"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_aiguillage_num),_("D3"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_aiguillage_num),_("D4"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_aiguillage_num),_("X1")); 

  TSGUI_aiguillage_posLabel = gtk_label_new (_("Position"));
  gtk_widget_show (TSGUI_aiguillage_posLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_aiguillagesHbox), TSGUI_aiguillage_posLabel, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_aiguillage_posLabel, 50, 15);

  TSGUI_aiguillage_pos = gtk_combo_box_entry_new_text ();
  gtk_widget_show (TSGUI_aiguillage_pos);
  gtk_box_pack_start (GTK_BOX (TSGUI_aiguillagesHbox), TSGUI_aiguillage_pos, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_aiguillage_pos, 183, 15);
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_aiguillage_pos),_(AIGUILLAGES_TXT_GAUCHE));
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_aiguillage_pos),_(AIGUILLAGES_TXT_CENTRE));
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_aiguillage_pos),_(AIGUILLAGES_TXT_DROITE));
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_aiguillage_pos),_(AIGUILLAGES_TXT_CROISEMENT));
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_aiguillage_pos),_(AIGUILLAGES_TXT_BIFURCATION)); 

  TSGUI_aiguillagesButton = gtk_button_new ();
  gtk_widget_show (TSGUI_aiguillagesButton);
  gtk_box_pack_start (GTK_BOX (TSGUI_aiguillagesHbox), TSGUI_aiguillagesButton, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_aiguillagesButton, 32, 15);

  image2 = gtk_image_new_from_stock ("gtk-ok", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image2);
  gtk_container_add (GTK_CONTAINER (TSGUI_aiguillagesButton), image2);

  TSGUI_hseparator2 = gtk_hseparator_new ();
  gtk_widget_show (TSGUI_hseparator2);
  gtk_box_pack_start (GTK_BOX (TSGUI_aiguillagesVbox), TSGUI_hseparator2, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_hseparator2, -1, 20);

  TSGUI_receptivitiesVbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (TSGUI_receptivitiesVbox);
  gtk_box_pack_start (GTK_BOX (TSGUI_rightVbox), TSGUI_receptivitiesVbox, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_receptivitiesVbox, 130, -1);

  TSGUI_receptivitesLabel = gtk_label_new (_("R\303\251ceptivit\303\251s"));
  gtk_widget_show (TSGUI_receptivitesLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_receptivitiesVbox), TSGUI_receptivitesLabel, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_receptivitesLabel, 44, 17);

  TSGUI_receptivitiesHbox = gtk_hbox_new (FALSE, 4);
  gtk_widget_show (TSGUI_receptivitiesHbox);
  gtk_box_pack_start (GTK_BOX (TSGUI_receptivitiesVbox), TSGUI_receptivitiesHbox, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_receptivitiesHbox, -1, 15);

  TSGUI_receptivities_octetLabel = gtk_label_new (_("Octet"));
  gtk_widget_show (TSGUI_receptivities_octetLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_receptivitiesHbox), TSGUI_receptivities_octetLabel, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_receptivities_octetLabel, 35, 15);

  TSGUI_receptivities_octet = gtk_combo_box_entry_new_text ();
  gtk_widget_show (TSGUI_receptivities_octet);
  gtk_box_pack_start (GTK_BOX (TSGUI_receptivitiesHbox), TSGUI_receptivities_octet, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_receptivities_octet, 183, 15);
  for(i=0;i<RECEPTIVITIES_READ_ALL_NB;i++){
	txt=(char*) malloc(100*sizeof(char));
	sprintf(txt,"%d",i);
  	gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_receptivities_octet),(gchar*) txt);
	free(txt);
  }

  TSGUI_receptivities_bitLabel = gtk_label_new (_("Bit"));
  gtk_widget_show (TSGUI_receptivities_bitLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_receptivitiesHbox), TSGUI_receptivities_bitLabel, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_receptivities_bitLabel, 15, 15);

  TSGUI_receptivities_bit = gtk_combo_box_entry_new_text ();
  gtk_widget_show (TSGUI_receptivities_bit);
  gtk_box_pack_start (GTK_BOX (TSGUI_receptivitiesHbox), TSGUI_receptivities_bit, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_receptivities_bit, 183, 15);
  for(i=0;i<RECEPTIVITIES_BITS_NB;i++){
	txt=(char*) malloc(100*sizeof(char));
	sprintf(txt,"%d",i);
  	gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_receptivities_bit),(gchar*) txt);
	free(txt);
  }

  TSGUI_receptivitiesButton = gtk_button_new ();
  gtk_widget_show (TSGUI_receptivitiesButton);
  gtk_box_pack_start (GTK_BOX (TSGUI_receptivitiesHbox), TSGUI_receptivitiesButton, FALSE, FALSE, 0);

  image3 = gtk_image_new_from_stock ("gtk-ok", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image3);
  gtk_container_add (GTK_CONTAINER (TSGUI_receptivitiesButton), image3);
  gtk_widget_set_size_request (image3, 24, 15);

  TSGUI_receptivitiesHbox2 = gtk_hbox_new (FALSE, 4);
  gtk_widget_show (TSGUI_receptivitiesHbox2);
  gtk_box_pack_start (GTK_BOX (TSGUI_receptivitiesVbox), TSGUI_receptivitiesHbox2, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_receptivitiesHbox2, -1, 15);

  TSGUI_receptivities_valueLabel = gtk_label_new (_("Valeur"));
  gtk_widget_show (TSGUI_receptivities_valueLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_receptivitiesHbox2), TSGUI_receptivities_valueLabel, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_receptivities_valueLabel, 40, 15);

  TSGUI_receptivities_value = gtk_combo_box_entry_new_text ();
  gtk_widget_show (TSGUI_receptivities_value);
  gtk_box_pack_start (GTK_BOX (TSGUI_receptivitiesHbox2), TSGUI_receptivities_value, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_receptivities_value, 183, 15);
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_receptivities_value),_("on"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_receptivities_value),_("off"));

  TSGUI_hseparator3 = gtk_hseparator_new ();
  gtk_widget_show (TSGUI_hseparator3);
  gtk_box_pack_start (GTK_BOX (TSGUI_receptivitiesVbox), TSGUI_hseparator3, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_hseparator3, -1, 20);

  TSGUI_trainsVbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (TSGUI_trainsVbox);
  gtk_box_pack_start (GTK_BOX (TSGUI_rightVbox), TSGUI_trainsVbox, TRUE, TRUE, 0);

  TSGUI_trainsLabel = gtk_label_new (_("Trains"));
  gtk_widget_show (TSGUI_trainsLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_trainsVbox), TSGUI_trainsLabel, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_trainsLabel, 44, 17);

  TSGUI_trainsHbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (TSGUI_trainsHbox);
  gtk_box_pack_start (GTK_BOX (TSGUI_trainsVbox), TSGUI_trainsHbox, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_trainsHbox, 130, 15);

  TSGUI_trains_numLabel = gtk_label_new (_("Num"));
  gtk_widget_show (TSGUI_trains_numLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_trainsHbox), TSGUI_trains_numLabel, FALSE, FALSE, 0);

  TSGUI_trains_num = gtk_combo_box_entry_new_text ();
  gtk_widget_show (TSGUI_trains_num);
  gtk_box_pack_start (GTK_BOX (TSGUI_trainsHbox), TSGUI_trains_num, TRUE, TRUE, 0);
  for(i=0;i<TRAINS_NB_LOCOMOTIVES;i++){
	txt=(char*) malloc(100*sizeof(char));
	sprintf(txt,"%d",TRAINS_NUMS[i]);
  	gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_trains_num),(gchar*) txt);
	free(txt);
  }

  TSGUI_trains_fctLabel = gtk_label_new (_("Fct"));
  gtk_widget_show (TSGUI_trains_fctLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_trainsHbox), TSGUI_trains_fctLabel, FALSE, FALSE, 0);

  TSGUI_trains_fct = gtk_combo_box_entry_new_text ();
  gtk_widget_show (TSGUI_trains_fct);
  gtk_box_pack_start (GTK_BOX (TSGUI_trainsHbox), TSGUI_trains_fct, TRUE, TRUE, 0);
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_trains_fct),_("on"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_trains_fct),_("off"));

  TSGUI_trains_invButton = gtk_button_new ();
  gtk_widget_show (TSGUI_trains_invButton);
  gtk_box_pack_start (GTK_BOX (TSGUI_trainsHbox), TSGUI_trains_invButton, FALSE, FALSE, 0);

  alignment1 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment1);
  gtk_container_add (GTK_CONTAINER (TSGUI_trains_invButton), alignment1);

  hbox8 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox8);
  gtk_container_add (GTK_CONTAINER (alignment1), hbox8);

  image4 = gtk_image_new_from_stock ("gtk-jump-to", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image4);
  gtk_box_pack_start (GTK_BOX (hbox8), image4, FALSE, FALSE, 0);

  label15 = gtk_label_new_with_mnemonic (_("INV"));
  gtk_widget_show (label15);
  gtk_box_pack_start (GTK_BOX (hbox8), label15, FALSE, FALSE, 0);

  TSGUI_trainsHbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (TSGUI_trainsHbox2);
  gtk_box_pack_start (GTK_BOX (TSGUI_trainsVbox), TSGUI_trainsHbox2, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_trainsHbox2, 130, 15);

  TSGUI_trains_speedLabel = gtk_label_new (_("Vitesse"));
  gtk_widget_show (TSGUI_trains_speedLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_trainsHbox2), TSGUI_trains_speedLabel, FALSE, FALSE, 0);

  TSGUI_trains_speed = gtk_combo_box_entry_new_text ();
  gtk_widget_show (TSGUI_trains_speed);
  gtk_box_pack_start (GTK_BOX (TSGUI_trainsHbox2), TSGUI_trains_speed, TRUE, TRUE, 0);
  for(i=TRAINS_CMD_NOFCT_ARRET;i<TRAINS_CMD_NOFCT_VITESSE_MAX;i++){
	txt=(char*) malloc(100*sizeof(char));
	sprintf(txt,"%d",i);
  	gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_trains_speed),(gchar*) txt);
	free(txt);
  }
  for(i=TRAINS_CMD_WITHFCT_ARRET;i<TRAINS_CMD_WITHFCT_VITESSE_MAX;i++){
	txt=(char*) malloc(100*sizeof(char));
	sprintf(txt,"%d",i);
  	gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_trains_speed),(gchar*) txt);
	free(txt);
  }

  TSGUI_trainsButton = gtk_button_new ();
  gtk_widget_show (TSGUI_trainsButton);
  gtk_box_pack_start (GTK_BOX (TSGUI_trainsHbox2), TSGUI_trainsButton, FALSE, FALSE, 0);

  image5 = gtk_image_new_from_stock ("gtk-ok", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image5);
  gtk_container_add (GTK_CONTAINER (TSGUI_trainsButton), image5);

  TSGUI_hseparator4 = gtk_hseparator_new ();
  gtk_widget_show (TSGUI_hseparator4);
  gtk_box_pack_start (GTK_BOX (TSGUI_trainsVbox), TSGUI_hseparator4, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_hseparator4, -1, 20);

  TSGUI_detelagesVbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (TSGUI_detelagesVbox);
  gtk_box_pack_start (GTK_BOX (TSGUI_rightVbox), TSGUI_detelagesVbox, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_detelagesVbox, 48, 33);

  TSGUI_detelagesLabel = gtk_label_new (_("Rails de d\303\251telages"));
  gtk_widget_show (TSGUI_detelagesLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_detelagesVbox), TSGUI_detelagesLabel, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_detelagesLabel, 46, 17);

  TSGUI_detelagesHbox = gtk_hbox_new (FALSE, 4);
  gtk_widget_show (TSGUI_detelagesHbox);
  gtk_box_pack_start (GTK_BOX (TSGUI_detelagesVbox), TSGUI_detelagesHbox, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_detelagesHbox, 48, 16);

  TSGUI_detelages_numLabel = gtk_label_new (_("Num"));
  gtk_widget_show (TSGUI_detelages_numLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_detelagesHbox), TSGUI_detelages_numLabel, FALSE, FALSE, 0);

  TSGUI_detelages_num = gtk_combo_box_entry_new_text ();
  gtk_widget_show (TSGUI_detelages_num);
  gtk_box_pack_start (GTK_BOX (TSGUI_detelagesHbox), TSGUI_detelages_num, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_detelages_num, 33, 15);
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_detelages_num),_(DETELAGES_TXT_DET1));
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_detelages_num),_(DETELAGES_TXT_DET2));
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_detelages_num),_(DETELAGES_TXT_DET3));

  TSGUI_detelages_stateLabel = gtk_label_new (_("Etat"));
  gtk_widget_show (TSGUI_detelages_stateLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_detelagesHbox), TSGUI_detelages_stateLabel, FALSE, FALSE, 0);

  TSGUI_detelages_state = gtk_combo_box_entry_new_text ();
  gtk_widget_show (TSGUI_detelages_state);
  gtk_box_pack_start (GTK_BOX (TSGUI_detelagesHbox), TSGUI_detelages_state, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_detelages_state, 31, 17);
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_detelages_state),_("on"));
  gtk_combo_box_append_text (GTK_COMBO_BOX (TSGUI_detelages_state),_("off"));

  TSGUI_detelagesButton = gtk_button_new ();
  gtk_widget_show (TSGUI_detelagesButton);
  gtk_box_pack_start (GTK_BOX (TSGUI_detelagesHbox), TSGUI_detelagesButton, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_detelagesButton, 32, 17);

  image10 = gtk_image_new_from_stock ("gtk-ok", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image10);
  gtk_container_add (GTK_CONTAINER (TSGUI_detelagesButton), image10);

  hseparator6 = gtk_hseparator_new ();
  gtk_widget_show (hseparator6);
  gtk_box_pack_start (GTK_BOX (TSGUI_detelagesVbox), hseparator6, TRUE, TRUE, 0);
  gtk_widget_set_size_request (hseparator6, -1, 20);

  TSGUI_cmdVbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (TSGUI_cmdVbox);
  gtk_box_pack_start (GTK_BOX (TSGUI_rightVbox), TSGUI_cmdVbox, FALSE, TRUE, 0);

  TSGUI_cmdLabel = gtk_label_new (_("Commandes"));
  gtk_widget_show (TSGUI_cmdLabel);
  gtk_box_pack_start (GTK_BOX (TSGUI_cmdVbox), TSGUI_cmdLabel, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_cmdLabel, 130, 17);

  TSGUI_cmd_simulButton = gtk_button_new ();
  gtk_widget_show (TSGUI_cmd_simulButton);
  gtk_box_pack_start (GTK_BOX (TSGUI_cmdVbox), TSGUI_cmd_simulButton, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_cmd_simulButton, 130, 25);

  alignment3 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment3);
  gtk_container_add (GTK_CONTAINER (TSGUI_cmd_simulButton), alignment3);

  hbox11 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox11);
  gtk_container_add (GTK_CONTAINER (alignment3), hbox11);

  image7 = gtk_image_new_from_stock ("gtk-select-color", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image7);
  gtk_box_pack_start (GTK_BOX (hbox11), image7, FALSE, FALSE, 0);

  label18 = gtk_label_new_with_mnemonic (_("Simulation"));
  gtk_widget_show (label18);
  gtk_box_pack_start (GTK_BOX (hbox11), label18, FALSE, FALSE, 0);

  TSGUI_cmd_realButton = gtk_button_new ();
  gtk_widget_show (TSGUI_cmd_realButton);
  gtk_box_pack_start (GTK_BOX (TSGUI_cmdVbox), TSGUI_cmd_realButton, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_cmd_realButton, 130, 25);

  alignment4 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment4);
  gtk_container_add (GTK_CONTAINER (TSGUI_cmd_realButton), alignment4);

  hbox12 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox12);
  gtk_container_add (GTK_CONTAINER (alignment4), hbox12);

  image8 = gtk_image_new_from_stock ("gtk-connect", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image8);
  gtk_box_pack_start (GTK_BOX (hbox12), image8, FALSE, FALSE, 0);

  label19 = gtk_label_new_with_mnemonic (_("Commander le circuit"));
  gtk_widget_show (label19);
  gtk_box_pack_start (GTK_BOX (hbox12), label19, FALSE, FALSE, 0);

  TSGUI_cmd_stopButton = gtk_button_new ();
  gtk_widget_show (TSGUI_cmd_stopButton);
  gtk_box_pack_start (GTK_BOX (TSGUI_cmdVbox), TSGUI_cmd_stopButton, FALSE, FALSE, 0);
  gtk_widget_set_size_request (TSGUI_cmd_stopButton, 130, 25);
  gtk_widget_set_sensitive(TSGUI_cmd_stopButton, FALSE);

  alignment5 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment5);
  gtk_container_add (GTK_CONTAINER (TSGUI_cmd_stopButton), alignment5);

  hbox13 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox13);
  gtk_container_add (GTK_CONTAINER (alignment5), hbox13);

  image9 = gtk_image_new_from_stock ("gtk-stop", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image9);
  gtk_box_pack_start (GTK_BOX (hbox13), image9, FALSE, FALSE, 0);

  label20 = gtk_label_new_with_mnemonic (_("Stop"));
  gtk_widget_show (label20);
  gtk_box_pack_start (GTK_BOX (hbox13), label20, FALSE, FALSE, 0);

  TSGUI_hseparator5 = gtk_hseparator_new ();
  gtk_widget_show (TSGUI_hseparator5);
  gtk_box_pack_start (GTK_BOX (TSGUI_rightVbox), TSGUI_hseparator5, TRUE, TRUE, 0);
  gtk_widget_set_size_request (TSGUI_hseparator5, -1, 39);

  TSGUI_statusBar = gtk_statusbar_new ();
  gtk_widget_show (TSGUI_statusBar);
  gtk_box_pack_start (GTK_BOX (TSGUI_mainContentDivider), TSGUI_statusBar, FALSE, FALSE, 0);

  g_signal_connect ((gpointer) TSGUI_quitter1, "activate",
                    G_CALLBACK (TSGUI_on_quitter1_activate),
                    NULL);
  g_signal_connect ((gpointer) TSGUI_about1, "activate",
                    G_CALLBACK (TSGUI_on_about1_activate),
                    NULL);
  g_signal_connect ((gpointer) TSGUI_signalisationButton, "pressed",
                    G_CALLBACK (TSGUI_on_signalisationbutton_pressed),
                    NULL);
  g_signal_connect ((gpointer) TSGUI_aiguillagesButton, "pressed",
                    G_CALLBACK (TSGUI_on_aiguillagesButton_pressed),
                    NULL);
  g_signal_connect ((gpointer) TSGUI_receptivitiesButton, "pressed",
                    G_CALLBACK (TSGUI_on_receptivitiesButton_pressed),
                    NULL);
  g_signal_connect ((gpointer) TSGUI_trains_invButton, "pressed",
                    G_CALLBACK (TSGUI_on_trains_invButton_pressed),
                    NULL);
  g_signal_connect ((gpointer) TSGUI_trainsButton, "pressed",
                    G_CALLBACK (TSGUI_on_trainsButton_pressed),
                    NULL);
  g_signal_connect ((gpointer) TSGUI_detelagesButton, "pressed",
                    G_CALLBACK (TSGUI_on_detelagesButton_pressed),
                    NULL);
  g_signal_connect ((gpointer) TSGUI_cmd_simulButton, "pressed",
                    G_CALLBACK (TSGUI_on_cmd_simulButton_pressed),
                    NULL);
  g_signal_connect ((gpointer) TSGUI_cmd_realButton, "pressed",
                    G_CALLBACK (TSGUI_on_cmd_realButton_pressed),
                    NULL);
  g_signal_connect ((gpointer) TSGUI_cmd_stopButton, "pressed",
                    G_CALLBACK (TSGUI_on_cmd_stopButton_pressed),
                    NULL);
  g_signal_connect(G_OBJECT(TSGUI_mainWindow), "delete-event",G_CALLBACK(TSGUI_on_Quit), NULL);
  g_signal_connect(TSGUI_circuitDrawingarea, "expose-event",G_CALLBACK(TSGUI_circuitDrawingarea_on_expose_event), NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (TSGUI_mainWindow, TSGUI_mainWindow, "TSGUI_mainWindow");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_mainContentDivider, "TSGUI_mainContentDivider");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_menuBar, "TSGUI_menuBar");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_menuitem1, "TSGUI_menuitem1");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_menuitem1_menu, "TSGUI_menuitem1_menu");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_quitter1, "TSGUI_quitter1");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_imageQuitter, "TSGUI_imageQuitter");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_menuitem4, "TSGUI_menuitem4");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_menuitem4_menu, "TSGUI_menuitem4_menu");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_about1, "TSGUI_about1");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_mainHbox, "TSGUI_mainHbox");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_leftVbox, "TSGUI_leftVbox");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_circuitDrawingarea, "TSGUI_circuitDrawingarea");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_logScrolledwindow, "TSGUI_logScrolledwindow");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_logTextView, "TSGUI_logTextView");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_mainVseparator, "TSGUI_mainVseparator");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_rightVbox, "TSGUI_rightVbox");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_signalisationVbox, "TSGUI_signalisationVbox");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_signalisationLabel, "TSGUI_signalisationLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_signalisationHbox, "TSGUI_signalisationHbox");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_signal_numLabel, "TSGUI_signal_numLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_signal_num, "TSGUI_signal_num");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_signal_colorLabel, "TSGUI_signal_colorLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_signal_color, "TSGUI_signal_color");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_signalisationButton, "TSGUI_signalisationButton");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, image1, "image1");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_hseparator1, "TSGUI_hseparator1");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_aiguillagesVbox, "TSGUI_aiguillagesVbox");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_aiguillagesLabel, "TSGUI_aiguillagesLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_aiguillagesHbox, "TSGUI_aiguillagesHbox");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_aiguillage_numLabel, "TSGUI_aiguillage_numLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_aiguillage_num, "TSGUI_aiguillage_num");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_aiguillage_posLabel, "TSGUI_aiguillage_posLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_aiguillage_pos, "TSGUI_aiguillage_pos");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_aiguillagesButton, "TSGUI_aiguillagesButton");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, image2, "image2");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_hseparator2, "TSGUI_hseparator2");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_receptivitiesVbox, "TSGUI_receptivitiesVbox");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_receptivitesLabel, "TSGUI_receptivitesLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_receptivitiesHbox, "TSGUI_receptivitiesHbox");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_receptivities_octetLabel, "TSGUI_receptivities_octetLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_receptivities_octet, "TSGUI_receptivities_octet");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_receptivities_bitLabel, "TSGUI_receptivities_bitLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_receptivities_bit, "TSGUI_receptivities_bit");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_receptivitiesButton, "TSGUI_receptivitiesButton");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, image3, "image3");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_receptivitiesHbox2, "TSGUI_receptivitiesHbox2");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_receptivities_valueLabel, "TSGUI_receptivities_valueLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_receptivities_value, "TSGUI_receptivities_value");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_hseparator3, "TSGUI_hseparator3");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_trainsVbox, "TSGUI_trainsVbox");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_trainsLabel, "TSGUI_trainsLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_trainsHbox, "TSGUI_trainsHbox");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_trains_numLabel, "TSGUI_trains_numLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_trains_num, "TSGUI_trains_num");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_trains_fctLabel, "TSGUI_trains_fctLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_trains_fct, "TSGUI_trains_fct");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_trains_invButton, "TSGUI_trains_invButton");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, alignment1, "alignment1");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, hbox8, "hbox8");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, image4, "image4");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, label15, "label15");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_trainsHbox2, "TSGUI_trainsHbox2");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_trains_speedLabel, "TSGUI_trains_speedLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_trains_speed, "TSGUI_trains_speed");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_trainsButton, "TSGUI_trainsButton");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, image5, "image5");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_hseparator4, "TSGUI_hseparator4");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_detelagesVbox, "TSGUI_detelagesVbox");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_detelagesLabel, "TSGUI_detelagesLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_detelagesHbox, "TSGUI_detelagesHbox");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_detelages_numLabel, "TSGUI_detelages_numLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_detelages_num, "TSGUI_detelages_num");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_detelages_stateLabel, "TSGUI_detelages_stateLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_detelages_state, "TSGUI_detelages_state");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_detelagesButton, "TSGUI_detelagesButton");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, image10, "image10");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, hseparator6, "hseparator6");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_cmdVbox, "TSGUI_cmdVbox");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_cmdLabel, "TSGUI_cmdLabel");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_cmd_simulButton, "TSGUI_cmd_simulButton");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, alignment3, "alignment3");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, hbox11, "hbox11");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, image7, "image7");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, label18, "label18");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_cmd_realButton, "TSGUI_cmd_realButton");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, alignment4, "alignment4");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, hbox12, "hbox12");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, image8, "image8");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, label19, "label19");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_cmd_stopButton, "TSGUI_cmd_stopButton");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, alignment5, "alignment5");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, hbox13, "hbox13");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, image9, "image9");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, label20, "label20");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_hseparator5, "TSGUI_hseparator5");
  GLADE_HOOKUP_OBJECT (TSGUI_mainWindow, TSGUI_statusBar, "TSGUI_statusBar");

  gtk_window_add_accel_group (GTK_WINDOW (TSGUI_mainWindow), accel_group);

  return TSGUI_mainWindow;
}

void TSGUI_update(int threadSafe){
	#ifndef TS_NOGUI
		if (threadSafe) gdk_threads_enter();
		while (gtk_events_pending ())
		  gtk_main_iteration_do(0);
		  gtk_main_iteration_do(0);
		  gtk_main_iteration_do(0);
		TSGUI_updateCircuit();
		//TSGUI_updateLog();
		if (threadSafe) gdk_threads_leave();
	#endif
}

void TSGUI_updateCircuit(void){
	#ifndef TS_NOGUI
		gtk_widget_draw(GTK_WIDGET(lookup_widget(GTK_WIDGET(TSGUI_mainWindow),"TSGUI_circuitDrawingarea")), NULL);
	#endif
}

void TSGUI_updateLog(void){
	#ifndef TS_NOGUI
		GtkTextIter end;
		GtkTextBuffer* TSGUI_logTextView_buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(lookup_widget(GTK_WIDGET(TSGUI_mainWindow),"TSGUI_logTextView")));

		gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(TSGUI_logTextView_buffer),&end);
		gtk_text_view_scroll_to_iter(GTK_TEXT_VIEW(lookup_widget(GTK_WIDGET(TSGUI_mainWindow),"TSGUI_logTextView")),&end,FALSE,TRUE,0.0,0.0);
		gtk_widget_draw(GTK_WIDGET(lookup_widget(GTK_WIDGET(TSGUI_mainWindow),"TSGUI_logTextView")), NULL);
	#endif
}
