/*------------------------------------------------------------------------------
** Projet : trainsim                                                         
** Auteurs : Vincent BONESTEVE, Dominique PADIOU                           
** Module : kernel                                                         
** Fichier : kernel_mod_circuit.c                                   
** Description : Module noyau circuit                           
------------------------------------------------------------------------------*/
/**
 * \file kernel_mod_circuit.c
 * \brief Module : kernel, Module noyau circuit
 * \author Vincent BONESTEVE, Dominique PADIOU 
 * \version 1.0-stable
 * \date 01/01/2010
 */
#include "kernel_mod_circuit.h"

/*
TSKERNEL_MOD_circuit
*/
int TSKERNEL_MOD_circuit_load(void){
	TSKERNEL_trace(TSKERNEL_CODE_USER,TSKERNEL_TRACE_INFO,"circuit : load begin");
	TSKERNEL_MOD_circuit_disjonction();
	TSKERNEL_MOD_circuit_conjonction();
	TSKERNEL_trace(TSKERNEL_CODE_USER,TSKERNEL_TRACE_INFO,"circuit : load end");
	return TSKERNEL_NORMAL_EXIT;
}

int TSKERNEL_MOD_circuit_unload(void){
	TSKERNEL_trace(TSKERNEL_CODE_USER,TSKERNEL_TRACE_INFO,"circuit : unload");
	TSKERNEL_MOD_circuit_disjonction();
	return TSKERNEL_NORMAL_EXIT;
}

int TSKERNEL_MOD_circuit_relachement(void){
	TSKERNEL_trace(TSKERNEL_CODE_USER,TSKERNEL_TRACE_INFO,"circuit : relachement");
	return TSKERNEL_CMD_interface_sendOneNoRelachement(CIRCUIT_RELACHEMENT);
}

int TSKERNEL_MOD_circuit_disjonction(void){
	TSKERNEL_trace(TSKERNEL_CODE_USER,TSKERNEL_TRACE_INFO,"circuit : disjonction");
	return TSKERNEL_CMD_interface_sendOneNoRelachement(CIRCUIT_DISJONCTION);
}

int TSKERNEL_MOD_circuit_conjonction(void){
	TSKERNEL_trace(TSKERNEL_CODE_USER,TSKERNEL_TRACE_INFO,"circuit : conjonction");
	return TSKERNEL_CMD_interface_sendOneNoRelachement(CIRCUIT_CONJONCTION);
}
