/*------------------------------------------------------------------------------
** Projet : trainsim                                                         
** Auteurs : Vincent BONESTEVE, Dominique PADIOU                           
** Module : kernel                                                         
** Fichier : kernel_mod_circuit.h                                    
** Description : Module noyau circuit                           
------------------------------------------------------------------------------*/
/**
 * \file kernel_mod_circuit.h
 * \brief Module : kernel, Module noyau circuit
 * \author Vincent BONESTEVE, Dominique PADIOU 
 * \version 1.0-stable
 * \date 01/01/2010
 */
#ifndef KERNEL_MOD_CIRCUIT_H
#define KERNEL_MOD_CIRCUIT_H
#include "const_circuit.h"
#include "const_kernel.h"
#include "kernel.h"
/*
TSKERNEL_MOD_circuit
*/
/**
 * \fn int TSKERNEL_MOD_circuit_load(void)
 * \brief Chargement du module
 * \return int code etat (see const_kernel.h)
 */
int TSKERNEL_MOD_circuit_load(void);
/**
 * \fn int TSKERNEL_MOD_circuit_unload(void)
 * \brief Dechargement du module
 * \return int code etat (see const_kernel.h)
 */
int TSKERNEL_MOD_circuit_unload(void);

/**
 * \fn int TSKERNEL_MOD_circuit_relachement(void)
 * \brief Envoie d'un ordre de relachement
 * \return int code etat (see const_kernel.h)
 */
int TSKERNEL_MOD_circuit_relachement(void);
/**
 * \fn int TSKERNEL_MOD_circuit_disjonction(void)
 * \brief Envoie d'un ordre de disjonction
 * \return int code etat (see const_kernel.h)
 */
int TSKERNEL_MOD_circuit_disjonction(void);
/**
 * \fn int TSKERNEL_MOD_circuit_conjonction(void)
 * \brief Envoie d'un ordre de conjonction
 * \return int code etat (see const_kernel.h)
 */
int TSKERNEL_MOD_circuit_conjonction(void);

#endif
