/*------------------------------------------------------------------------------
** Projet : trainsim                                                         
** Auteurs : Vincent BONESTEVE, Dominique PADIOU                           
** Module : string                                                     
** Fichier : string_extra.c                                    
** Description : Module string                         
------------------------------------------------------------------------------*/
/**
 * \file string_extra.c
 * \brief Module : string
 * \author Vincent BONESTEVE, Dominique PADIOU 
 * \version 1.0-stable
 * \date 01/01/2010
 */
#include "string_extra.h"

char **str_split(char *s, const char *ct){
	char **tab = NULL;
	if (s != NULL && ct != NULL){
		int i;
		char *cs = NULL;
		size_t size = 1;

		for (i = 0; (cs = strtok (s, ct)); i++){
			if (size <= i + 1){
				void *tmp = NULL;
				size <<= 1;
				tmp = realloc (tab, sizeof (*tab) * size);
				if (tmp != NULL){
					tab = tmp;
				} else {
					free (tab);
					tab = NULL;
					return tab;
				}
			}
			tab[i] = cs;
			s = NULL;
		}
		tab[i] = NULL;
	}
	return tab;
}
