/*------------------------------------------------------------------------------
** Projet : trainsim                                                         
** Auteurs : Vincent BONESTEVE, Dominique PADIOU                           
** Module : const                                                        
** Fichier : const_api.h                                    
** Description : Constantes des operations de l'API                        
------------------------------------------------------------------------------*/
/**
 * \file const_api.h
 * \brief Module : const, Constantes des opérations de l'API
 * \author Vincent BONESTEVE, Dominique PADIOU 
 * \version 1.0-stable
 * \date 30/12/2009
 */
#ifndef CONST_API_H
#define CONST_API_H
/*
Socket protocol
*/
#define API_QUERY_START_CHAR '$'
#define API_QUERY_END_CHAR '|'

#define API_ANSWER_START_CHAR '$'
#define API_ANSWER_END_CHAR '|'

#define API_DELIMITER_CHAR ';'

#define API_QUERY_START_STR "$"
#define API_QUERY_END_STR "|"

#define API_ANSWER_START_STR "$"
#define API_ANSWER_END_STR "|"

#define API_DELIMITER_STR ";"

/*
Op code
*/
#define API_OPCODE_ANSWER 0
#define API_OPCODE_INIT 1 //DEPRECATED
#define API_OPCODE_END 2 //DEPRECATED
#define API_OPCODE_TRACE 3 //NOT USED

#define API_OPCODE_AIGUILLAGES_SETPOS 4

#define API_OPCODE_BLOCKS_MUTEX_P 5
#define API_OPCODE_BLOCKS_MUTEX_V 6

#define API_OPCODE_CIRCUIT_RELACHEMENT 7
#define API_OPCODE_CIRCUIT_DISJONCTION 8
#define API_OPCODE_CIRCUIT_CONJONCTION 9

#define API_OPCODE_DETELAGES_GETPOS 10
#define API_OPCODE_DETELAGES_SETPOS 11

#define API_OPCODE_RECEPTIVITIES_GET 12

#define API_OPCODE_SIGNALISATION_SET 13
#define API_OPCODE_SIGNALISATION_GET 14

#define API_OPCODE_TRAINS_GETSPEED 15
#define API_OPCODE_TRAINS_GETPOS 16
#define API_OPCODE_TRAINS_SETSPEED 17
#define API_OPCODE_TRAINS_REVERSE 18
#define API_OPCODE_TRAINS_CREATE 19
#define API_OPCODE_TRAINS_DELETE 20

#endif
