/*------------------------------------------------------------------------------
** Projet : trainsim                                                         
** Auteurs : Vincent BONESTEVE, Dominique PADIOU                           
** Module : const                                                        
** Fichier : const_receptivities.h                                    
** Description : Constantes pour la gestion des receptivites                           
------------------------------------------------------------------------------*/
/**
 * \file const_receptivities.h
 * \brief Module : const, Constantes pour la gestion des receptivites
 * \author Vincent BONESTEVE, Dominique PADIOU 
 * \version 1.0-stable
 * \date 30/12/2009
 */
#ifndef CONST_RECEPTIVITIES_H
#define CONST_RECEPTIVITIES_H
/*
Codes etat
*/
#define RECEPTIVITIES_STATE_INIT -1
#define RECEPTIVITIES_STATE_OFF 0
#define RECEPTIVITIES_STATE_ON 1

/*
Codes instruction
*/
#define RECEPTIVITIES_INS_TRANSMISSION_EFFACEMENT 192
#define RECEPTIVITIES_INS_TRANSMISSION_MAINTIEN 128

/*
Bits
*/
#define RECEPTIVITIES_BITS_NB 8

/*
Lecture globale
*/
#define RECEPTIVITIES_READ_ALL_3_DECODERS 131
#define RECEPTIVITIES_READ_ALL_NB 6

/*
Lecture selective
*/
#define RECEPTIVITIES_READ_SELECT_NB 2
#define RECEPTIVITIES_READ_SELECT_DECODER_1 193
#define RECEPTIVITIES_READ_SELECT_DECODER_2 194
#define RECEPTIVITIES_READ_SELECT_DECODER_3 195

static int RECEPTIVITIES_READ_SELECT_DECODERS[3] = {193,194,195};

/*
Receptivites par block
*/
//Format = [i][j1][j2][j3] (jx in clockwise circuit order)
#define RECEPTIVITIES_OFFSET_OCTET 0
#define RECEPTIVITIES_OFFSET_R1 1
#define RECEPTIVITIES_OFFSET_R2 2
static int RECEPTIVITIES_G1[4]={6,5,6,7};
static int RECEPTIVITIES_G2[4]={4,5,6,7};

static int RECEPTIVITIES_B1[3]={3,5,6};
static int RECEPTIVITIES_B2[3]={5,6,7};
static int RECEPTIVITIES_B3[3]={5,1,0};
static int RECEPTIVITIES_B4[3]={5,3,2};
static int RECEPTIVITIES_B5[3]={5,5,4};
static int RECEPTIVITIES_B6[3]={3,4,7};
static int RECEPTIVITIES_B7[3]={3,2,3};
static int RECEPTIVITIES_B8[3]={3,0,1};
static int RECEPTIVITIES_B9[3]={1,3,2};
static int RECEPTIVITIES_B10[3]={1,1,0};
static int RECEPTIVITIES_B11[3]={1,7,6};
static int RECEPTIVITIES_B12[3]={2,6,7};
static int RECEPTIVITIES_B13[3]={2,0,1};
static int RECEPTIVITIES_B14[3]={2,2,3};
static int RECEPTIVITIES_B15[3]={1,4,5};
static int RECEPTIVITIES_B16[3]={2,5,4};

#endif
