/*------------------------------------------------------------------------------
** Projet : trainsim                                                         
** Auteurs : Vincent BONESTEVE, Dominique PADIOU                           
** Module : usr                                                        
** Fichier : usr.c                                     
** Description : Espace utilisateur
** MODIFIER CE FICHIER A VOTRE CONVENANCE POUR CREER VOS PARCOURS DE TRAINS
** EN UTILISANT LES FONCTIONS DE api_kernel.h
** N'UTILISER PAS DE BOUCLES INFINIES DANS VOS FONCTIONS (UTILISER LE MODE 
** CYCLIQUE)                    
------------------------------------------------------------------------------*/
/**
 * \file usr.c
 * \brief Module : usr, programme des trains
 * \author Vincent BONESTEVE, Dominique PADIOU 
 * \version 1.0-stable
 * \date 01/01/2010
 */
#include "usr.h"

void TSUSR_train1_init(void){
	int train_num=TRAINS_LOCOMOTIVE_1;

	//Depart block 14
	TSAPI_blocks_mutex_P(BLOCKS_B14,train_num);
}

void TSUSR_train1_loop(void){
	int train_num=TRAINS_LOCOMOTIVE_1;
	int train_speed=TRAINS_CMD_WITHFCT_VITESSE_5;
	int train_speed_stop=TRAINS_CMD_WITHFCT_ARRET;
	int train_fct=TRAINS_FCT_ON;
	
	//Block 8
	TSAPI_blocks_mutex_P(BLOCKS_B8,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B14[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B8[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B8[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B14,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B14[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 2
	TSAPI_blocks_mutex_P(BLOCKS_B2,train_num);
	TSAPI_aiguillages_setPosition("D2","droite");
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B8[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B2[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B2[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B8,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B8[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 1
	TSAPI_blocks_mutex_P(BLOCKS_B1,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B2[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B1[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B1[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B2,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B2[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 3
	TSAPI_blocks_mutex_P(BLOCKS_B3,train_num);
	TSAPI_aiguillages_setPosition("D1","gauche");
	TSAPI_aiguillages_setPosition("S1","gauche");
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B1[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B3[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B3[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B1,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B1[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 9
	TSAPI_blocks_mutex_P(BLOCKS_B9,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B3[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B9[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B9[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B3,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B3[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 15
	TSAPI_blocks_mutex_P(BLOCKS_B15,train_num);
	TSAPI_aiguillages_setPosition("D3","droite");
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B9[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B15[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B15[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B9,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B9[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 16
	TSAPI_blocks_mutex_P(BLOCKS_B16,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B15[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B16[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B16[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B15,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B15[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 14
	TSAPI_blocks_mutex_P(BLOCKS_B14,train_num);
	TSAPI_aiguillages_setPosition("D4","gauche");
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B16[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B14[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B14[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B16,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B16[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
}
void TSUSR_train2_init(void){
	int train_num=TRAINS_LOCOMOTIVE_2;
	//Depart block 13
	TSAPI_blocks_mutex_P(BLOCKS_B13,train_num);
}

void TSUSR_train2_loop(void){
	int train_num=TRAINS_LOCOMOTIVE_2;
	int train_speed=TRAINS_CMD_WITHFCT_VITESSE_5;
	int train_speed_stop=TRAINS_CMD_WITHFCT_ARRET;
	int train_fct=TRAINS_FCT_ON;

	//Block 16
	TSAPI_blocks_mutex_P(BLOCKS_B16,train_num);
	TSAPI_aiguillages_setPosition("D4","centre");
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B13[SIGNALISATION_SENS_2],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B16[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B16[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B13,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B13[SIGNALISATION_SENS_2],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 15
	TSAPI_blocks_mutex_P(BLOCKS_B15,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B16[SIGNALISATION_SENS_2],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B15[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B15[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B16,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B16[SIGNALISATION_SENS_2],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 10
	TSAPI_blocks_mutex_P(BLOCKS_B10,train_num);
	TSAPI_aiguillages_setPosition("D3","centre");
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B15[SIGNALISATION_SENS_2],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B10[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B10[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B15,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B15[SIGNALISATION_SENS_2],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 4
	TSAPI_blocks_mutex_P(BLOCKS_B4,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B10[SIGNALISATION_SENS_2],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B4[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B4[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B10,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B10[SIGNALISATION_SENS_2],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 1
	TSAPI_blocks_mutex_P(BLOCKS_B1,train_num);
	TSAPI_aiguillages_setPosition("D1","centre");
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B4[SIGNALISATION_SENS_2],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B1[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B1[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B4,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B4[SIGNALISATION_SENS_2],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 2
	TSAPI_blocks_mutex_P(BLOCKS_B2,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B1[SIGNALISATION_SENS_2],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B2[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B2[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B1,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B1[SIGNALISATION_SENS_2],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 7
	TSAPI_blocks_mutex_P(BLOCKS_B7,train_num);
	TSAPI_aiguillages_setPosition("D2","centre");
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B2[SIGNALISATION_SENS_2],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B7[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B7[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B2,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B2[SIGNALISATION_SENS_2],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 13
	TSAPI_blocks_mutex_P(BLOCKS_B13,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B7[SIGNALISATION_SENS_2],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B13[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B13[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B7,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B7[SIGNALISATION_SENS_2],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
}

void TSUSR_train3_init(void){
	int train_num=TRAINS_LOCOMOTIVE_3;
	//Depart block 2
	TSAPI_blocks_mutex_P(BLOCKS_B2,train_num);
}

void TSUSR_train3_loop(void){
	int train_num=TRAINS_LOCOMOTIVE_3;
	int train_speed=TRAINS_CMD_WITHFCT_VITESSE_5;
	int train_speed_stop=TRAINS_CMD_WITHFCT_ARRET;
	int train_fct=TRAINS_FCT_ON;

	//Block 1
	TSAPI_blocks_mutex_P(BLOCKS_B1,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B2[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B1[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B1[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B2,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B2[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 5
	TSAPI_blocks_mutex_P(BLOCKS_B5,train_num);
	TSAPI_aiguillages_setPosition("D1","droite");
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B1[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B5[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B5[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B1,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B1[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 11
	TSAPI_blocks_mutex_P(BLOCKS_B11,train_num);
	TSAPI_aiguillages_setPosition("X1","bifurcation");
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B5[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B11[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B11[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B5,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B5[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 15
	TSAPI_blocks_mutex_P(BLOCKS_B15,train_num);
	TSAPI_aiguillages_setPosition("D3","gauche");
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B11[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B15[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B15[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B11,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B11[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 16
	TSAPI_blocks_mutex_P(BLOCKS_B16,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B15[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B16[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B16[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B15,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B15[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 12
	TSAPI_blocks_mutex_P(BLOCKS_B12,train_num);
	TSAPI_aiguillages_setPosition("D4","droite");
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B16[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B12[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B12[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B16,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B16[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 6
	TSAPI_blocks_mutex_P(BLOCKS_B6,train_num);
	TSAPI_aiguillages_setPosition("X1","bifurcation");
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B12[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B6[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B6[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B12,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B12[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
	//Block 2
	TSAPI_blocks_mutex_P(BLOCKS_B2,train_num);
	TSAPI_aiguillages_setPosition("D2","gauche");
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B6[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_GREEN);
	while(TSAPI_receptivities_get(RECEPTIVITIES_B2[RECEPTIVITIES_OFFSET_OCTET],RECEPTIVITIES_B2[RECEPTIVITIES_OFFSET_R1])==RECEPTIVITIES_STATE_OFF){
		TSAPI_trains_setSpeed(train_num,train_speed,train_fct);
	}
	TSAPI_blocks_mutex_V(BLOCKS_B6,train_num);
	TSAPI_signalisation_setState(SIGNALISATION_SIGNAUX_B6[SIGNALISATION_SENS_1],SIGNALISATION_COLOR_RED);
	TSAPI_trains_setSpeed(train_num,train_speed_stop,train_fct);
}

void TSUSR_main(void){
	//Creation des trains
	TSAPI_trace(TSUSR_TRACE_INFO,"usr : create trains");
	TSAPI_trains_createItinerary(TRAINS_LOCOMOTIVE_1,BLOCKS_B14,TSUSR_TASKS_CYCLIC,TSUSR_train1_init,TSUSR_train1_loop,NULL);
	TSAPI_trains_createItinerary(TRAINS_LOCOMOTIVE_2,BLOCKS_B13,TSUSR_TASKS_CYCLIC,TSUSR_train2_init,TSUSR_train2_loop,NULL);
	TSAPI_trains_createItinerary(TRAINS_LOCOMOTIVE_3,BLOCKS_B2,TSUSR_TASKS_CYCLIC,TSUSR_train3_init,TSUSR_train3_loop,NULL);
	TSAPI_trace(TSUSR_TRACE_INFO,"usr : end create trains");
}
