/*------------------------------------------------------------------------------
** Projet : trainsim                                                         
** Auteurs : Vincent BONESTEVE, Dominique PADIOU                           
** Module : usr                                                        
** Fichier : usr.h                                    
** Description : Espace utilisateur                     
------------------------------------------------------------------------------*/
/**
 * \file usr.h
 * \brief Module : usr, programme des trains
 * \author Vincent BONESTEVE, Dominique PADIOU 
 * \version 1.0-stable
 * \date 01/01/2010
 */
#ifndef USR_H
#define USR_H
#include <stdlib.h>
#include "api_usr.h"
#include "usr_const_global.h"
#include "usr_const_tasks.h"
#include "const_trains.h"
#include "const_blocks.h"
#include "const_signalisation.h"
#include "const_receptivities.h"

/*
TSUSR
*/
/**
 * \fn void TSUSR_train1_init(void)
 * \brief Initialisation du train 1
 * \return void
 */
void TSUSR_train1_init(void);
/**
 * \fn void TSUSR_train1_init(void)
 * \brief Boucle du train 1
 * \return void
 */
void TSUSR_train1_loop(void);

/**
 * \fn void TSUSR_train1_init(void)
 * \brief Initialisation du train 2
 * \return void
 */
void TSUSR_train2_init(void);
/**
 * \fn void TSUSR_train1_init(void)
 * \brief Boucle du train 2
 * \return void
 */
void TSUSR_train2_loop(void);

/**
 * \fn void TSUSR_train1_init(void)
 * \brief Initialisation du train 3
 * \return void
 */
void TSUSR_train3_init(void);
/**
 * \fn void TSUSR_train1_init(void)
 * \brief Boucle du train 3
 * \return void
 */
void TSUSR_train3_loop(void);

/**
 * \fn void TSUSR_main(void)
 * \brief Programme principal utilisateur
 * \return void
 */
void TSUSR_main(void);
#endif
