/*------------------------------------------------------------------------------
** Projet : trainsim                                                         
** Auteurs : Vincent BONESTEVE, Dominique PADIOU                           
** Module : usr_const                                                        
** Fichier : usr_const_tasks.h                                    
** Description : Constantes interne pour la gestion des taches                        
------------------------------------------------------------------------------*/
/**
 * \file usr_const_tasks.h
 * \brief Module : usr_const, Constantes internes pour la gestion des taches
 * \author Vincent BONESTEVE, Dominique PADIOU 
 * \version 1.0-stable
 * \date 31/12/2009
 */
#ifndef USR_CONST_TASKS_H
#define USR_CONST_TASKS_H

/*
Ressources
*/
#define TSUSR_TASKS_NB_MAX_CPU 1
#define TSUSR_TASKS_ATTENTE_MAX 20

/*
Cyclic type
*/
#define TSUSR_TASKS_ONESHOT 0
#define TSUSR_TASKS_CYCLIC 1
#define TSUSR_TASKS_CYCLIC_AUTO 2

/*
Real-Time type
*/
#define TSUSR_TASKS_HARD_RT 1
#define TSUSR_TASKS_SOFT_RT 0

#define TSUSR_TASKS_PERIOD 1000000
#define TSUSR_TASKS_taskname(x) (1000 + (x))

#endif
